2008-12-30
(*) Fixed minor threading bugs.

2008-12-29
(*) Fixed editor drag selection bug.
(*) Made error report submission more concise.
(*) Fixed crash on editing play mode too quickly.
(*) Fixed some multiplayer null bugs.
(*) Many small potential bug fixes.

2008-12-28
(*) Fixed autoplay discrepancies.
(*) Fixed replay export in multiplayer games.
(*) Fixed date display on ranking screen in multiplayer games.

2008-12-27
(+) Added alert when friends go offline.
(+) Added team mode support (framework only) to match setup and bancho.
(+) Added new chat commands '/addfriend <user>' and '/delfriend <user>'.  The user must be online when adding.
(+) Tag mode current player arrow bounces!
(*) Fixed mousewheel not being fully handled by sprite import dialog.

2008-12-25
(*) Changed default resolution to 1024x.
(*) Fix for some video types not working.
(*) Fix for some cultures not retrieving scores.

2008-12-24
(+) Added performance graph in tag mode ranking.
(+) Lobby shows new match details.
(*) Fixed failing on tag play mode.
(*) Increased accuracy of performance emulation.
(*) Increased input range for local user.
(*) Fixed CtB spinners in tag play mode.
(*) Changed dropdown menu behaviour slightly.
(*) Fixed tag play with more than two players.
(*) Local player gains control in breaks.
(*) Restricted tag mode to osu! standard play only.
(*) Fixed mouse not expanding in tag mode.
(*) Fixed chat not always auto-hiding in tag mode.
(*) Reduced CPU load at ranking screen (after playing through a song).
(*) Tag play games don't end if a player quits.

2008-12-23
(+) Dropdown menus can use the click-drag-release selection method.
(*) Fixed window not flashing on highlights.
(*) Fixed timing problem when toggling frame limiter (animation speed affected until restarting osu!).
(*) Fixed notes at end of tag sequence (for non-local player) being missed in some cases.
(*) Fixed forced fail at end of tag play for active player.
(*) Increased leniance on slider performance actualisation in tag play.
(*) Tag play arrow fades out during breaks.
(*) Web: Database restructuring.

2008-12-22
(+) Added new key binding options.  Reorganised existing.
(+) F7 toggles frame limiter from anywhere in-game.
(*) Tag arrow dissipates during breaks.
(*) Fixed some bugs during tag swapover in rare cases.
(*) Fixed chat autohiding during tag gameplay.
(*) Fixed flashlight not following local mouse in tag play.
(*) Fixed tagged player after spinner being incorrect.

2008-12-21
(+) Online rating can be seen on song selection screen.
(*) Tag mode has arrow marking current player.
(*) Performance of sliders is transferred to all players in tag mode.
(*) All players fail together in tag mode.
(*) Many minor bug fixes in tag mode.

2008-12-18
(+) Performance of hitcircles in tag mode can be seen by all players (sliders don't work so well yet).
(*) Score and combo are sync'd in tag mode.
(*) Fixed score disable in tag mode.
(*) Many bug fixes and improvements to tag mode.

2008-12-17
(+) More tag-play framework.
(*) Halved flashlight texture size.  Should help with older graphics cards not being able to display it.
(*) /np can be used multiple times on the same song after a certain period of time.

2008-12-16
(+) Hit performance can be seen on the multiplayer scoreboard.
(+) Added framework for multiplayer team modes.
(*) Fixed MSN integration status not saving to configuration.
(*) Fixed preferred skins for beatmaps not loading the first time a beatmap is played.

2008-12-15
(+) Added admin command '!g' to Bancho.
(+) Added ability to push updates to menu overlay via Bancho while users are at the screen.
(+) Added ability to force clients to check update based on test version status or username.
(*) Highlight words check for surrounding characters for exact matching.
(*) Fixed '#multiplaye..' tab.
(*) Fixed friend detection in scoreboards.
(+) Web: Added audio previews in beatmap listing.

2008-12-14
(+) Added support for loading title screen overlay images from web.
(+) Added win condition type to multiplayer games (score or accuracy at the moment).
(+) Added ability to add more highlights for your name in chat.
(+) Text boxes have a caret cursor.
(+) Friends will be displayed in a darker shade on in-game scorelists (during play mode).
(*) New main menu layout.
(*) Fixed animations not saving framerate correctly in SBE.
(*) Fixes to spinner detection when in fullscreen.
(*) Fixed bug where spectating is impossible in rare cases after leaving the multiplayer lobby.
(*) Fixed autoplay in test mode causing weird effects when being enabled too early.
(*) Changed user popup option to "start chat" rather than "send private message".
(*) Changed test mode so it doesn't fade in on load (does this feel better?).
(*) Fixed spinner mouse restriction range.
(*) Chat window performance improvements on some systems.

2008-12-13
(+) Added Yahoo integration.
(+) Added button on timing panel to set offset of selected timing point to current time.
(*) Fixed distance spacing status not being read from configuration correctly.
(*) Fixed taiko spinner bugs.
(*) Fixed game getting stuck in always-on-top mode.
(+) Web: BAT who ranked map is visible on beatmap listing.  Slight design changes to make listing more compact/readable.

2008-12-12
(+) Added new bindings and improved binding interface layout.
(+) Added MSN integration.  Can be toggled on under Online Options screen. (thanks to Jeffro for sample code)
(*) Bindings are checked for conflicts.
(*) Fixed taiko spinner bug.
(*) Fixed chat buttons being visible while a popup dialog is active.
(*) Middle mouse button no longer exits multiplayer games (must use Escape or your pause binding).
(+) Web: Added RSS feed for ranked beatmaps.

2008-12-11
(+) New keyboard binding ui and framework.
(*) Changed UO options text.

2008-12-10
(*) Database optimisations.

2008-12-09
(*) Removed "Scroll Locking.." alert text.
(*) Fixed /np showing incorrect mod/play status after playing a song.

2008-12-08
(+) Added new maintenance tab in options.
(+) Added option to delete all unranked maps.
(*) BSS will not allow submission to the pending forum without at least two difficulties being present.
(*) Fixed unranked map deletion process to handle maps which have one difficulty or more made by the local user (but are unranked).
(+) Web: Added beatmap thumbnails to beatmap listing and beatmap info pages (two sizes).
(+) Web: Added thumbnails to most played listing.  Creators are linked to profiles.

2008-12-07
(*) Storyboard editor bug fixes.
(*) BSS modifications for notifying server of storyboard presence.
(!) Catch the Beat score reset, multiplier changes.
(+) Web: Added storyboard/video icons to beatmap listing.

2008-12-06
(*) Fixed vector scale not handling floats correctly when resaving to .osu.

2008-12-05
(*) Disabled spectator mode while in editor and test modes.
(*) Storyboard Editor fixes.
(+) Web: Added Country Ranking page.
(+) Web: Added country flags to player ranking, beatmap score rankings.

2008-12-04
(+) Browsing for sprites in sprite library works correctly.
(+) Event depth order can be rearranged by dragging the event names on the right-hand list.
(+) Storyboard Editor timeline shows all four types of transformations at once.
(*) Fixed problem with removing end-point keyframes.

2008-12-03
(+) Added event list to storyboard editor.
(+) Added sprite library dialog to storyboard editor.
(*) Fixed background not saving properly in editor.
(*) Fixed fading background in editor not working correctly when changing modes.
(*) Fixed moving offset forward in timing screen possibly causing first note not to be automatically shifted.

2008-12-02
(+) Added support for .osb writing.
(+) Added support for difficulty specific storyboarding (write to .osu).
(+) Added full undo/redo support for storyboard editor.
(*) osu! is always on top while playing.

2008-12-01
(+) Added new metadata argument "time" for exact title time-wise positioning.
(+) Added origin position choice.
(+) Removing keyframes correctly joins surrounding tweens.
(*) Fixed cursor skinning not working correctly.
(*) Fixed cursor not hiding properly.
(*) Fixed alignment of high score ranks on song select.
(*) Fixed [wait] argument not displaying correctly in song metadata on long waits.
(*) Fixed song selection sorting issues with same artist/title but different creator.
(*) Changed multipliers for HardRock and DoubleTime in Catch the Beat mode.
(*) Increased size of flashlight in Catch the Beat mode.
(*) Fixed star rating not displaying properly on ranking dialog.

2008-11-30
(+) Added tween handling.
(+) Inprovements in many areas of storyboard editor.
(+) Keyframe navigation and manipulation.
(*) Changed internal handling of sprite alpha channel.

2008-11-29
(+) Added different colours for subscribers and BATs in chat.
(+) Movement tween support in design mode.
(*) Fixed fade during breaks in editor not acting correctly.
(*) Fixed crash when sending message too fast on first Bancho login.
(*) Changed process priority settings for main osu! thread.

2008-11-28
(+) Added new editor framework.

2008-11-26
(*) Fixed fps counter not hiding correctly if enabled on startup.
(*) Fixed adding bookmarks in test mode causing stacked positions to get saved to beatmap file.
(*) Fixed relax mod crashing on completion of a beatmap (as approaching the ranking screen).
(*) Fixed osu!direct percentable decimal disappearing on whole numbers.
(*) Fixed random crashing on entering test mode.
(*) Fixed '/savelog' sending to channel.
(*) Fixed mouse cursor not appearing when updating changes to your own map dialog appears.
(*) Changed colour of non-timing-change control points to green in seek bar.

2008-11-25
(*) Improved performance on test mode for some PCs.
(*) Fixed window position of open dialog in editor.
(*) Changing difficulty in the File > Open dialog can be used to preview difficulties before loading.  Useful for comparison.

2008-11-23
(*) Rating shows up for your own maps on ranking dialog.
(*) Fixed search not totally obeying ranked/unranked criteria.
(*) Chat window has a delay on moving user panels around after scrolling.
(*) Fixed problem with spinners in autoplay.

2008-11-22
(+) Added new achievement.
(+) Song ratings are visible after playing songs (even after you have already rated it).
(+) Song selection mode graphic pulsates with the beat.  And rotates in 2/3 of the modes.
(+) Added taiko barlines.  Thinking they should be a bit thicker.
(*) Slider point editing defaults to grid snapping.
(*) Fixed bug where placing slider head and end on same grid location (with no line) causes weird artifacts.
(*) Fixed random editor crashing.
(*) Fixed editor crashing on undo/redo.
(*) Text drawing performance improvements (~20%).
(*) Fixed lag occurring on test mode on some PCs.
(*) Fixed updater autostart option not being saved to correct config file.
(*) Updater no longer has Libraries\ dependency - this is automatically deleted next time you run osume.  New public osume is also available for those that really care.
(*) 'Watch Replay' button doesn't appear if it isn't necessary (online rank > 40).

2008-11-21
(*) Improved modifying position of objects in editor (boundary conditions).
(*) Ported bsdiff algorithm to native c#.  Much more reliable patching in osume.

2008-11-20
(*) Removed stopwords from fulltext search index.  Beatmap searching should work better now.
(*) Bancho fixes.
(*) osu! fixes to play nicer with Bancho.
(*) Fixed /chat twice on same user crashing osu!.

2008-11-19
(*) Fixed bancho not saving channels on restart.
(*) Fixed incorrect rankings showing up in wrong mode.
(*) Fixed relax mod scores being saved locally.
(*) Fixed combo fire disappearing in CtB when no notes are hit for more than a second or so.
(*) Fixed first note spinner throwing off colour index in CtB mode by one.
(*) Fixed test mode bugging when enabling autoplay after the last hitcircle.
(*) Small improvement in load time of beatmaps with many breaks.
(*) Enabled CtB play mode scoreboards.
(*) Fixed /me and /np in private chat tabs.
(*) CtB ignores skin custom colours.

2008-11-18
(*) Improved performance of in-game score retrieval substantially.
(*) Web: Improved site beatmap listing performance over 40x.
(*) Web: Front page 'Most Played' info includes CtB plays.
(*) Web: Total play count in header includes CtB plays.
(!) Web: upppy! performance improvements.

2008-11-17
(+) Added line number to storyboard error popup.
(+) Added HP drain to Catch the Beat mode.
(+) Added osu!direct support for all forum pickups.
(+) Ctrl-C in design mode will copy current ms time to clipboard.
(*) Friend online alerts are queued and combined into a single alert.
(*) Fixed folder sorting.
(*) Changed query tab display to be more easy to follow.
(*) Removed 1 second elay between pauses in test mode.
(*) Fixed CtB rounding error.
(*) Fixed CtB missing aligned hits if PC lag occurs.
(*) Fixed editor getting stuck if save is cancelled when opening another difficulty.
(*) Fixed skip being possible via space bar when it shouldn't be.
(*) Fixed tab overflow.
(*) Middle-screen popups appear above the extended chat pane.
(*) Fixed link matching for osu!direct chat pickups.

2008-11-16
(+) Added catch the beat ranking support.  Don't say anything about this publicly - going to keep it a surprise for tomorrow's release.  Any score you achieve before public release will be wiped, but please test out the scoreboards/replays.
(+) Added local score support for all game modes.
(+) Added replay export support for all game modes.
(+) osu!direct supports forum links in chat (t=* and p=*) for beatmap pickup.
(+) Added toggle for spectator list display.
(+) Added web access icon to edit mode song select.
(*) Increased harshness of fruits accuracy/rank calculations.
(*) Fixed fruits replay accuracy.
(*) Optimisations of local score database handling.  Should be about 10x as fast.
(+) Alerts when friends come online.
(*) Fixed window flashing not working.
(*) Fixed yucky combo fire when going yellow -> blue -> yellow -> blue.
(*) Fixed fellow spectators list disappearing randomly.
(*) Fixed crash when trying to change volume of a timing section when there are no timing sections.
(*) CatchTheBeat hard mod equation improvements.
(*) Some graphics changes.
(!) Database fixes, replay purging, general maintenance.

2008-11-15
(*) Fixed spectator crashing bug.
(*) Fixed bug when enabling autoplay while paused in test mode (you can't do this anymore).
(*) Fixed 'approved' status message not displaying on starting play of a beatmap.
(*) Fixed occasional crash on clicking unpause cursor.
(*) Fixed bancho threading issues with sending stats (very occasional disconnect).

2008-11-14
(+) Added icons on song select for current mode (not finalised, the osu! one looks a bit shoddy).
(*) Fixed /bb not working with previous code changes.
(*) Fixed combo counter not appearing smoothly.
(*) Fixed autoplay not hitting first note if it is at offset 0.
(*) Fixed new songs (mp3s) not displaying in song selection.
(*) Fixed chat window not hiding in time when first hitobject is too close to start of mp3.
(*) Fixed pause while failing bug.
(*) Fixed level overflow for people hitting level 99.
(*) Score submission database optimisations.

2008-11-13
(+) Added '/clear' command support to in-game chat.
(*) Fixed autoplay spinners on taiko mode.
(*) Fixed taiko spinners giving 100 hits no matter what.
(*) BSS window is no longer resizeable.

2008-11-12
(+) Added support for private chat tabs. /chat or /query to open one.
(*) Fixed mouse clip being set incorrectly after res change in fullscreen (i hope).
(*) Fixed 'awpbad' bug.
(*) Fixed last frame of replays not playing back.
(*) Main menu volume changes are retained.
(*) Fixed spectator getting stuck at ranking screen if host user retries too quickly.
(*) Fixed chat buttons causing impossible unpause if mouse cursor is located over one of them before a delayed pause.
(*) Fixed CtB replays missing at high playback speeds (32x).
(*) Changed effect of buttons appearing on dialog popups.
(*) Audio playing prior to entering offset wizard is restored on exit.
(*) Fixed capitalisation of retries message.
(*) Fixed spinner being 0.5 pixels misaligned.
(*) Increased robustness of mouse cursor display (better in opengl especially).
(*) Fixed bug causing editor to crash when using timing point inheritance in some cases.
(*) Fixed order of sorting for 'Newest Maps' option in osu!direct.

2008-11-11
(*) Overall load speed increase by 9000?  A lot anyway.
(*) Increased osu!.db read speed by 80%.
(*) Increased beatmap scanning speed by 25%.
(*) Fixed colour changing in editor.
(*) Fixed avatars not loading correctly.
(*) Reduced size of osu!.db by 50%.
(*) Main menu osu! logo ignores inhereted timing sections.
(*) Reduced number of audio samples loaded at startup.
(*) Moved SkinManager initialisation to point of use, rather than startup.
(*) Moved hash cache to common config file, rather than per-user setup.
(*) Improved performance of opening difficulties in editor.
(*) Improved startup performance.

2008-11-10
(+) BSS window flashes when upload is complete.
(+) Number of retries on a single play session are shown (>2).
(*) Fixed song selection not searching in source field.
(*) Allow isntant unpausing while in test mode.
(!) Finished judging beatmap competition maps :p.
(!) Web: Updated terms and conditions, an added warning about multiple accounts and no username changing.

2008-11-09
(+) osu! configuration is stored on a per-windows-user basis.
(+) Added osu! uptime to menu screen.
(*) Fixed slider->hitcircle conversion occurring on taiko-specific maps when it shouldn't.
(*) Fixed 'SongSelectActiveText' skin colour not working as expected.
(*) Fixed crash when selecting "Clear All Notes' in editor.
(*) Fixed inserting bookmarks in test mode causing a hard crash.
(*) Fixed spectating taiko plays not working correctly.
(*) Fixed osu!direct bug where game would crash on downloading an older beatmap.
(*) Drastically reduced taiko HP increase rate.

2008-11-08
(+) HardRock mode for fruits increases the jumpiness of fruit spacing (yes this is a bit dodgy atm).
(+) Bookmarks can be added from test mode (hit 'B').

2008-11-06
(*) Fixed mods displaying twice on ranking screen.
(*) Fixed size of hit100 sprite on ranking screen.
(*) Fixed offset wizard crash if closed then opened again while downloading tutorial.
(*) Fixed progress metre on song select not moving.
(*) Fixed crash on initialisation in some rare thread race conditions.
(*) Fixed ranking sprites appearing after end of map in some cases (when mp3 ends very suddenly after last hitobject).
(*) Fixed random threading issues using scheduling.
(*) Fixed sound when clicking menu items on special mode selection screen.

2008-11-05
(+) Added tutorial to osume distribution.
(+) Offset wizard automatically downloads the tutorial.
(+) Added scheduling support for events occurring on main thread.  This is cool, but a lot of code needs to be rewritten to benefit.
(+) Added special support for the tutorial.
(+) Added fruits ranking screen.
(*) Added support for hp graph lines on OpenGl.
(*) Ranking screen animated in when spectating.
(*) Fixed spectating causing random freezes which require hard restart of osu!.
(*) Changed fruits scoring, rank and accuracy calculations.

2008-11-04
(+) Added mousewheel volume adjustment/volume display to main menu.
(+) Beatmap store will be refreshed on exiting osu!direct (full mode) if downloads were completed.
(*) Fixed beatmap-specific skinned cursor sticking after exiting a beatmap.
(*) Changed offset wizard to use tutorial song.
(*) Fixed holding middle mouse button stopping replay from working.

2008-11-03
(+) Multiplayer play mode is displayed in lobby listing.
(*) Fixed bug with BSS submission.
(*) Fixed slider bars not following mouse.
(*) Fixed rounding errors on offset wizard.
(*) Added new combo storyboard change support in fruits mode.
(*) Changed taiko break pass/fail graphic to be based off accuracy (>80% is passing).
(*) Fixed alignment of multiplayer scoreboard for resolutions under 1024x.
(*) Improved replay accuracy with sliders.
(*) Improved auto accuracy. (100% on marisa @ 3200% speed while frapsing).

2008-11-02
(+) Added '/ignore', '/unignore' commands.
(+) Can use quick jump with 'F7' from main menu.
(*) Fixed flashlight crash.
(*) Fixed red tint shader effect persisting after fail.
(*) Fixed slider misses not showing miss cross at both ends.
(*) Fixed bug where aborting an osu!direct download would render it impossible to download the same map again.
(*) Decreased traffic required when sending request for updated beatmap information.
(*) Increased interval betweel osu! packet sends.
(*) FPS counter no longer blocks chat buttons.
(*) Fixed bug where songs duplicate on first import when no osu! database is present locally.
(*) Huge multiplayer bug fixes.
(*) Bancho low-level communication improvements.
(*) Improved handling of unplayed maps.

2008-11-01
(+) Added osu!direct support to spectator mode.
(+) Added check for flashlight texture issues.
(*) Fixed scoreboard appearing in edit mode.
(*) Fixed in-game dialog messages not displaying in editor properly.
(*) Fixed random characters displaying when clicking a player box in multiplayer as host.
(*) Fixed update bar on main menu losing background after returning to the main menu from another play mode.
(*) Fixed timing changes not prompting for a save in editor.
(*) Fixed threading issues on bancho disconnects.
(*) Fixed flashlight not following mouse properly on slower PCs.
(*) Fixed textured not rendering correctly in OpenGl mode on some PCs.
(*) Fixed vertical flipping not working in storyboard scripting.
(*) Separated GL and DX framesync (so GL defaults to having it turned off - this seems to be a better default).
(+) Web: Added "Link This" links on each FAQ entry.  Use it to link users directly to that entry with minimal fuss.
(*) Web: Fixed play history graph showing skewed stats when over 11 months of play history was present.

2008-10-31
(*) Fixed osu!direct link handling to pickup links with old 'index.php' style.
(*) Fixed ranking dialog not showing online ranking stats.
(*) Fixed taiko autoplay to handle claps correctly.
(*) Fixed pausing causing problems with submission.
(*) Fixed fruits spectator broken with new dash binding.
(*) Restored left-mouse dash mode independent of binding.

2008-10-30
(+) Added test bancho toggle.
(+) Added bancho protocol version negotiation. (Means test client can connect to old and new bancho).
(*) Fixed ranking dialog attempting to display online stats for unrankable game modes.
(*) Improved extended chat load time 20 fold.  Slight performance increase too.
(*) Avatars are loaded progressively in the background to decrease perceived lag.
(*) Removed red tint shader effect when playing taiko mode.
(*) Fixed hide/show chat button being visible during song outro.
(*) Fixed incorrect cursor show/hide behaviour with fullscreen dialogs.

2008-10-29
(+) Added key binding for dash mode.  Defaults to shift.
(*) Fixed play mode not set correctly to 'osu!' when entering edit song selection mode.
(*) Fixed mods not being reset when changing between game modes.
(*) Fixed max combo not displaying in editor test mode.
(*) Fixed crash occurring when using '/np' while the current song is not yet downloaded in multiplayer games.
(*) Fixed crash when disabling some mods.
(*) Fixed spectating not playing back correctly, and failing in some cases.
(*) Fixed autoplay not working in editor in some cases.
(*) Fixed taiko mode failing if first hit is missed.
(+) Web: Added user graph to front page.

2008-10-28
(+) Taiko HP calculations.
(+) Auto-hiding of mouse cursor when idle in taiko/fruits game modes.
(+) Added 'dash' mode to fruits.  Use left or right hit binding.
(+) Added small light flashes for fruits tick collection.
(+) Added hidden support for fruits mode.
(+) Added flashlight support for fruits mode.
(+) Play mode is visible in /np messages.
(*) Fruits lighting is based on combo.
(*) Fixed replay for multiple game modes.
(*) Fixed movement speed during halftime and doubletime fruits mode.
(*) Improved fruits autoplay algorithm (less jittery during sliders).
(*) Fixed taiko mode failling on completiong of any song with sliders.
(*) Fixed some downloads failing in osu!direct (now they will show an error rather than crashing osu!).
(*) Fixed spinner metre starting at 100%.
(*) Fixed spinner not fading out to black at the top.
(*) Fixed brown fire (for real, i swear).
(*) Removed spun out support for fruits.
(*) Changed descriptions of mode-specific mod features.
(*) Fixed update dialog appearing in edit mode.
(*) Fixed buttons on update dialog occasionally not appearing correctly in OpenGl mode.

2008-10-27
(+) Current gameplay mode is sent when submitting scores.
(+) Added special menu background, basic button effects.
(*) Spinner finish has a white flash on plate.
(*) Flahes are bound to plate.
(*) Song selection returns to special menu when clicking back.
(*) Fixed osu!direct links for ancient beatmaps crashing osu!.
(*) Fixed random crashing when starting play mode.
(*) Fixed crash on spectating in some cases.

2008-10-26
(*) Changed way unplayed maps are stored locally (implemented in database).
(*) Increased leniancy on bancho timeout (up to two failures before disconnect).
(*) Vast improvement in performance when changing between sorting modes.
(*) Improved song selection performance.
(*) Fixed slider copy/paste/undo not working correctly in editor.
(*) Fixed status being reported as playing when autoplay is enabled in some cases.
(*) Fixed fail on completion of some game modes.
(*) Fixed progress metre not fading out on song completion.
(*) Fixed editor getting some fruits in it.
(*) Fixed fruits icon being too gray on initial menu load.
(*) Fixed lead-in not behaving correctly with fruits.
(*) Fixed occasional crash after spectating.
(*) Fixed taiko spinner being completed by holding down both mouse buttons.
(*) Improved spinner playback accuracy.
(*) Increased volume of soft clap.

2008-10-25
(+) Added fruit spinner support.
(*) Improvements to fruit sliders.
(*) Fixed blue fire turning brown in some rare cases.
(*) Fixed background colour resetting when using Song Setup panel.
(*) Fixed slider rotation bug.
(*) Fixed HP drain formula.
(*) Fruit autoplay improvements.
(!) More major code refactoring.

2008-10-24
(+) Fruit autoplay support.
(*) Fruit is behind the plate (or on it, as it appears).
(*) Fruit combo counter changes.
(*) Fruit sliders handle sound samples and slider endpoints much nicer.
(*) Fixed bug where chat messages are cut off in some cases.
(*) Reduced size of info request when importing a new beatmap to an existing osu! instance.
(*) Changed behaviour of clicking a beatmap on osu!direct fullscreen mode.
(*) File transfers more efficient.
(*) Fixed osu!direct not deleting temporary files on cancellation.
(*) Fixed osu!direct completion effects not working correctly in some conditions.
(*) Fixed taiko combo position.
(*) Fixed problem with flashing sprite code.

2008-10-23
(*) Fruits improvements (slider handling, combo handling, plate catching).
(*) Fixed HP bar initial increase not working correctly.
(*) Reenabled score submission.  New test build should be out tomorrow.

2008-10-22
(+) Fruits handles sliders.

2008-10-21
(+) Initial implementation of 'Fruits' game mode.
(*) Goto time dialog in editor accepts more naturally formatted times (mm:ss, mm:ss:ms etc.)
(!) Huge code refactoring.

2008-10-20
(+) New icon for special game modes thanks to LuigiHann.
(+) Added template special menu.
(+) Multiplayer games support play mode.
(*) Reintroduced scoring screen after relax plays on request.
(*) Fixed incorrect starting modes during multiplayer.
(*) Fixed banchobot dodginess with !search.
(*) Fixed score submission rules.
(*) Fixed more editor bugginess.
(*) Fixed osu!direct panel % not reaching the far-right correctly.
(*) Fixed osu!direct panel sometimes not displaying.
(*) Taiko mode can be unpaused without positioning the mouse cursor correctly.
(*) Reorganised mod screen without taiko.
(*) No more relax mod in taiko mode.
(!) Known issues: backwards compatibility with multiplayer taiko not handled.  Spectator with taiko not handled at all.

2008-10-19
(+) All BATs are automatically chat admins (when using osu! to connect).
(+) User statuses are distributed by Bancho.
(*) Fixed dodgy slider point selection in editor.
(!) Code refactoring epicness.

2008-10-18
(+) Added initial version of osu!direct panel management system.
(+) osu!direct handles links in chat.
(+) Added friend list support.
(+) Added 'Special' mode selection button to main menu.  Currently just enables Taiko mode.
(*) osu!direct selection download status is visible even after searching again.
(*) Doubled performance of extended chat display.
(*) Offset wizard falls back to currently playing song if specific one is not available.
(*) Fixed '/watch' crash if no username is specified.
(*) Fixed shaking notes moving from their set location.
(*) Changed look of scrollbars.

2008-10-17
(+) Added bancho status for osu!direct.
(*) Bug reports contain more detailed information including current beatmap and play mode.
(*) Fixed bug where songs folder could be deleted when choosing to delete an unmapped mp3 from song select (sorry rolled).
(*) Fixed osu!direct fail message appearing inappropriately during multiplayer downloads.
(*) Fixed mouse cursor clipping to a certain bounds when osu! is minimised in fullscreen mode.
(*) Fixed mouse cursor clipping to wrong bounds when the window is moved during play mode.
(*) Fixed occasional crashes on initialisation of multiplayer game.
(*) Fixed bug where transferring host in multiplayer game means the host can no longer select maps.
(!) HUGE code refactoring.  Its a pity I can't share the beauty of this with you guys :).

2008-10-16
(*) Fixed pausing at main menu not working correctly.
(*) Fixed slider point placement when distance snap is enabled.
(*) Fixed bug where osu! crashes while unpausing (on clicking the resume cursor).
(*) Fixed 'UNRANKED' display being based off local mods during spectator/replay.
(!) Start of a huge code refactor which could delay public release slightly.  Still aiming for Sunday, though.

2008-10-15
(+) Distance Snap toggle status is preserved.
(+) Added 1280x960 menu option in editor.
(+) Added two new skin colour variables: SongSelectActiveText and SongSelectInactiveText.
(+) Added warning notices for 1/3 and 1/6 snap divisors.
(*) Fixed OpenGl fullscreen mode.
(*) Fixed cursor able to leave to second monitor during fullscreen play.
(*) Fixed bug with automatic offset/bpm adjustments when inheriting timing.
(*) When spectating, the chat is only closed on the initial song load, and only the user panel (full mode) is closed instead of all.
(*) Combo fire checkbox is no longer selectable in OpenGl mode.
(*) Fixed tooltips exiting the edge of the screen at lower resolutions.  Changed positioning slightly in all cases.
(*) Removed old Universal Offset search method.
(*) Random songs continue shuffling while on the options menu.

2008-10-14
(+) OpenGl screenshot implemented (F12 key).
(*) OpenGl slider rendering complete.  I don't think I can make them look any better without shaders.  So let's not go there.
(*) Vastly improved repositioning notes/sliders while distance snap is toggled on.  Objects will no longer "snap" to be centered on the cursor.
(*) Fixed distance snap failure turning the wrong icon red.
(*) Fixed combo fire error for OpenGl options dialog.

2008-10-13
(+) Added OpenGL fallback for cards that don't support ARB texture extensions (Intel integrated graphics).
(*) OpenGl texture extension choice efficiently chooses best available method based on hardware.
(*) Improved spinner peformance by around 100%.
(*) Improved video performance by around 100%.
(*) Improved the look of gl sliders (a bit).
(*) Increased 'passing' standard for O/X in break.

2008-10-12
(+) OpenGl rectangle primitive support.
(+) OpenGl slider rendering (basic) added.
(+) OpenGl frame sync (limit framerate) option now supported.  Try toggling to check performance.
(*) When direct3d fails to start up, users are given the option to swap to OpenGl or not, rather than forcing this behaviour.
(*) Distance snap enabled by default.
(*) Improved performance of beatmap title display (at start of play mode).
(*) Fixed FPS counter setting not saving correctly.

2008-10-11
(+) OpenGl line primitive support.
(+) OpenGl editor support mostly complete.
(*) Fixed bugs when changing resolution in opengl mode.

2008-10-09
(+) Added osu!direct integration in multiplayer mode.
(+) Added toggle for progress bar positioning (with 3 positioning modes).
(+) Added button to access Echo's offset wizard.

2008-10-08
(*) Fixed crash when opening osz files etc when osu! is already open.

2008-10-07
(*) Must be logged in to view online scores (avoids various consequences of not having bancho connection).

2008-10-06
(*) Fixed autoplay replays saying "played by local player".
(*) Fixed mouse disappearing at strange times.

2008-10-05
(*) Bancho fixes.

2008-10-04
(+) Clicking the bpm/offset in timing mode selects the appropriate field in timing popup.
(+) New dialog for importing beatmaps.
(*) Fixed storyboard animations running too slow.
(*) Fixed mouse not appearing on initial login screen in OpenGl renderer mode.
(*) Fixed message popups turning white after mouse hover.
(*) Minor changes to error reporting dialog.
(*) Bancho !search is always private.  Uses new searching algorithm (fulltext rather than part-matching).
(*) Bancho IRC quit message overflow fixes.

2008-10-02
(*) Fixed colour of popups turning white unexpectedly.
(*) Fixed mouse locking to osu! window when enabling autoplay in editor test mode.

2008-10-01
(+) Added subtle progress bar to play mode.
(+) Added option to run at 1280x960.
(+) Added toggle for fps counter.
(+) Added nocaps support to Bancho.
(*) Fixed fps drop during slider display (especially noticeable during snaking).
(*) Better error displayed when attempting to BSS a map with no hit objects.
(*) A few internal security improvements.

2008-09-30
(+) First testing release with OpenGl support.  Keep in mind editor doesn't work and sliders don't render.  Changing resolutions requires a restart.  Fullscreen doesn't work.  Combo fire/shaders are not supported.
(+) GL renders in standard window.
(+) GL runs with no DirectX dependencies (but will not work with Mono yet due to many native calls).
(+) Added toggle for FPS display and GL/D3D renderer.
(*) Editor won't prompt to save a map if no changes are made.
(*) Reorganisation of options menu.

2008-09-29
(+) GL renderer loads sprites from raw data.
(+) GL renderer loads sprites from files and streams correctly.
(+) GL video displays correctly (still using directshow for rendering).
(*) Improvements to download code.

2008-09-28
(+) GL renderer supports sprites to an equal level of DX renderer.  Can't handle reading textures from disk yet (reads via DX memory)
(*) Fixed newline escapes in chat.
(*) Fixed video seeking randomly when stopped at 00:00:00.
(*) Fixed bug with snapping notes using inhereted timing sections.
(*) Fixed bancho bug causing multiplayer chat to appear in active chat buffer (needs bancho restart).

2008-09-27
(+) Can copy timing information to clipboard (Ctrl+C at timing screen).
(*) Fixed spinner autoplay bug.
(*) Fixed timing setup window not selecting current timing point correctly when using Inherit mode.

2008-09-26
(*) .osb files are not asked to be deleted when exporting maps in editor.
(*) Fixed 'clap' sample notes not working correctly in Taiko Mod.
(*) Fixed personal score not updating correctly when clicking 'retry' at ranking screen.
(*) Fixed slider selection glow sticking when creating repeat sliders.
(*) Fixed osu!direct showing newest maps for wrong categories.

2008-09-25
(+) Initial framework for powerup play mode.
(*) Osz v2 export/import works correctly at first stage of implementation. go echo!
(*) Changed slider highlighting in editor to be more like before endpoint sample assignment.  Should feel better.
(*) Editor code refactoring (huge internal changes).
(*) A notice is displayed when a segment is too short to insert break time.
(*) 3 D.P. bpm is only displayed while ctrl is held down (fine adjustment mode).
(*) Fixed personal online high score not updating on scoreboard when choosing retry from ranking screen.
(*) Fixed rank swapping bug 'ZOMMMMMG' etc.
(*) Local offset adjustment is back to 5ms intervals.  Hold Alt to get 1ms changes.
(*) Local offset is adjusted when a new online offset is found, rather than reset. newLocal = local - online.

2008-09-24
(+) Editor exports in osz2 format (beta).
(+) osz2 format can be imported (but doesn't really work yet).
(*) Fixed Autoplay/SpunOut/Flashlight not displaying on	/np.
(*) Fixed some sliders being misinterpreted as triple time tick rate.
(*) Fixed a bancho client-wide crash under certain conditions.
(*) Fixed some osu!direct crashes.

2008-09-23
(*) Fixed spunout crashing osu! when selected in multiplayer.
(*) Fixed chat buttons not disappearing when 'auto hide' is set to false.
(*) Fixed some server-side multiplayer issues on Bancho.

2008-09-22
(*) BPM is editable to the third decimal place.
(*) Sprite class accounts for load time when assigning transformations.
(*) Fixed mods not displaying in multiplayer mod selection dialog.
(*) Fixed chat buttons not hiding during gameplay for some users.
(*) Fixed hp bar exceeding its maximum bounds when PC is lagging.
(*) Fixed rare spinner display order bug.
(*) Fixed osu!direct default display mode being inaccurate.
(*) Fixed custom override in timing window not loading previews correctly.
(*) Fixed random editor sprite appearances.
(*) Fixed ghost matches bug with duped logins.
(*) Fixed '/r' not working for usernames with spaces.

2008-09-21
(+) Added new sound sample 'clap'.
(+) Added display options to osu!direct.
(*) Storyboarded samples stop playing when paused/failed.
(*) Music loops correctly in osu!direct.

2008-09-20
(+) Added 'Jump To' box. Use 'j' at main menu to activate.
(+) Slider endpoint selection works in timeline.
(+) osu!direct button on main menu.
(+) Downloads can be aborted.
(*) Fixed changing game name in multiplayer breaking reaady status.
(*) Fixed novideo not working in multiplayer (I mean it this time).
(*) Fixed some osu!direct bugs.
(+) Web: Implemented beatmap limit of 8 for subscribers (3 base, 5 based on ranked maps).

2008-09-18
(+) Added 'wait' argument to metadata display.
(+) User permissions are sent by bancho to osu! client.
(+) User permissions are displayed on main menu.
(*) Display title generated by BSS.
(*) Better effects on display title.
(*) Fixed copying multisample sliders not copying sample setup.
(*) Fixed 'NAMES' list not compatible with mirc.
(*) A few more anti-spam Bancho limitations added.
(*) Fixed text alignment on BSS window.
(*) Fixed pending/ranked status not being read correctly from database.

2008-09-16
(+) Support for online offset adjustments.
(+) Support for online metadata reading.
(+) Custom offset is displayed on song selection screen.
(+) Added progress bar for song selection wheel.
(+) Added progress bar for music player on main menu.
(*) Fixed tags not loading correctly on importing new beatmaps.
(*) Fixed multiple monitor support?  Kind of.
(*) Adding/removing favourites can be done without entering favourite grouping mode.
(*) Web: Tags/Source can be searched from web beatmap listing.
(*) Web: Changed beatmap searching to use fulltext search methods.

2008-09-15
(+) Netcode supports deflate http Content-Encoding type.
(+) Online Selection makes it clear when a song is already available locally.  Prompts for confirmation before downloading.
(*) Fixed threading bugs (song selection and online selection).
(+) Unified sampleset sliders have blue borders when selecting, non-unified are red.
(*) Fixed catchup behaviour when window is inactive for long periods.
(*) Fixed some bugs with sample assignment in editor.
(*) Fixed volume display depth problem.
(*) Implemented faster random number generation code.  Improves starburst performance marginally.
(*) Reduced loading time when first opening chat console.

2008-09-14
(+) Added UNRANKED graphic to notify player they are not being ranked.
(+) Added volume indicator when adjusting volume in play mode.
(*) Fixed soft sampleset not correctly getting assigned samples.
(*) Taiko slider algorithm FIXED.  This should make taiko mode with standard beatmaps a LOT more playable.
(*) Fixed taiko rolls not displaying correctly.
(*) Fixed taiko large hits not getting dual button presses in autoplay.
(*) Fixed autoplay being usable in multiplayer.  Eek.
(*) Taiko autoplay cursor is no longer visible.
(*) Fixed editor dealing with slider samples and combos.
(*) Fixed problems with map filenames containing '#'.
(*) Fixed autoplay bug in test mode when completing a map with autoplay on.
(*) More minor slider graphic adjustments.
(*) Sliders are more transparent than before.

2008-09-13
(+) New mod 'Autoplay'.
(+) New mod 'Spun Out'.
(+) Autoplay can be toggled in editor test mode.
(*) Fixed a few threading bugs.
(*) Fixed novideo status being reset after each multiplayer game.
(*) Fixed taiko-specific maps not always playing in taiko mode in multiplayer games.
(*) Fixed resolution bug when selecting "Edit" from beatmap menu in song selection while running in fullscreen.
(*) Fixed chat nickname matching failing on symbols '+' etc.
(*) Fixed some maps not showing grade on song selection wheel.
(*) Fixed timing point inheritance not saving in editor.
(*) Fixed timing point inheritance not transferring sampleset changes etc.
(*) Fixed resolution dependent replay problems.
(*) Improvements to spinner speed accuracy on slower PCs.
(*) Spinner replay playback is perfected.
(*) Hard limited hitcircles to the playfield range.
(*) Removed shaking notes on combobreak (decided it looks gay).

2008-09-11
(+) Added two new pack-based achievements.
(*) Fixed spinners bugging on combobreak.
(*) Slider endpoint editing basically working (except editor won't correctly show the current state of the sample additions).
(*) Web: New subforums for languages.  Subforums also visible on forum listing.

2008-09-10
(+) Sliders shake when hit too early (like circles).
(+) Notes shake on combo break.
(+) .osu support for slider endpoint sample separation.

2008-09-09
(*) Increased security for private releases.
(*) Online Selection downloads to a temporary folder to prevent incomplete downloads from cluttering imports.
(*) Fixed file associations.

2008-09-08
(+) Blue fire for combos over 500 hits.
(+) Slider endpoints can be selected in editor.  This is the beginning of the ability to alter sound additions per-endpoint.  More to come..
(*) New online selection graphics.
(*) Editor shows times to the millisecond.
(*) Triple timing sliders really fixed?  Maybe?  Matty??
(*) Fixed ratings not displaying in online selection for some cultures.
(*) Fixed file associations being broken for new installs of osu! (old users only).
(*) Clicking your own panel in F9 view brings up different options.

2008-09-07
(*) Fixed secondary sort not working in many cases.
(*) Fixed web links not working in online selection.

2008-09-06
(+) In-game download support initial release.
(+) Added sort mode 'Rank'.
(*) Fixed combofire height during hard rock.
(*) Fixed some lobby crashes.
(*) Fixed rank not displaying after completing approved maps (on ranking popup).
(*) Removed approved mode message for replays.

2008-09-02
(+) Added toggle for comboburst.
(*) Reduced Flashlight multiplier to 1.12x.
(*) Fixed display bug in multiplayer lobby.
(*) Fixed some songs not selectable in song select (near the top of the list).
(*) Fixed bug with repeating sliders.
(*) Changed spinner RPM to reflect actual mouse spinning speed (rather than spinner revolutions).
(*) Fixed bancho ghost multiplayer games.
(*) Web: Flashlight scores display correctly.

2008-09-01
(+) Added '/watch' to quickly spectate a user.
(*) Fixed nothing playing after deleting a beatmap.
(*) Seconary sort is group-based.
(*) Fixes to pause resuming (when clicking is disabled).
(*) Sprite engine fixes.
(*) Replay/spectator mode fixes.
(*) Triple-time repeat slider fixes.
(*) Song selection sorting fixes.
(*) Fixed source appearing in forum thread subect.d

2008-08-31
(+) Added message to explain the new unpause method.
(+) Implemented secondary sorting.
(*) Fixed show chat button disappearing when skip+paused.
(*) Mouse via keyboard controls work for pause menu etc.
(*) Slider animation improvements.
(*) Fixed prblem with 1/3 snap repeat sliders.

2008-08-30
(*) Change pause resume method.
(*) Fixed spectator list not displaying in some cases.
(*) Fixed player acting like host in some situations.
(*) Fixed bug with masked sprite display (visible on mp lobby).
(*) Flashlight mod adjusts size depending on performance.

2008-08-29
(*) Temporarily removed pause changes.  New implementation tomorrow.

2008-08-27
(+) Personal online best can be seen in play-mode scoreboard, highlighted orange-red.
(+) Added local user's user panel to multiplayer match setup.  Stats increases will display here after completing a multiplayer game.
(*) Improvements to pause algorithm.
(*) Fixed '/me' actions highlighting the user which types them.
(*) Fixed timing changes in the timing setup window making sliders disappear.
(*) Fixed popup dialogs not displaying while spectating.
(*) Spectator mode can't be initialised while playing (to avoid accidental spectating).
(*) Added 'Stop Spectating' option to currently spectating user's ioption list.
(*) Increased leniancy of Bancho flood protection (ever so slightly).
(*) Fixed Bancho flood protection kicking in during error reports.
(*) Slightly more visibility during LightsOut.

2008-08-26
(*) Fixed multiplayer mods being carried across to single player.
(*) Sudden death kills on missing a slider tick.
(*) Group By dropdown works correctly, and is ordered alphabetically.
(*) Quick tabs are different when in edit mode.
(*) Fixed edit mode crash bug.

2008-08-25
(+) Added lights-out mode to flashlight.
(+) New button for selection options.
(*) Improved gameplay performance with fewer external function calls (may help fight "lag"?)
(*) Show chat button now defaults to showing minimal chat mode, even if extended chat was previously visible.
(*) Fixed keyboard selection not working after selecting a new category.
(*) Fixed songs not allowing editor speed changes after first import.
(*) Fixed avatar masking error in extended chat display.
(*) New icon for flashlight mod.
(*) Song selection tidy-up.

2008-08-24
(+) New animation on ranking screen.
(+) Added shutter sound when taking a screenshot (F12).
(+) Added option to specify a preferred skin in editor.  Use sparingly, please.
(*) BSS dialog changes.
(*) Song selection bug fixes and touchups.
(*) osu! will open the beatmap listing if no beatmaps are present.
(*) Stars are more throwable, and bounce off walls.
(*) Fixed PM support to BanchoBot.  Added shortcut '/bb', so you can do things like '/bb search'.
(*) Updater won't quit when displaying skins.

2008-08-23
(*) Added shaddow to spectators list for maps with white backgrounds.
(*) Speed optimisations for song selection screen.
(*) General code cleanup.
(*) Changed slider colouring yet again.
(*) Internal skinning changes, allows for quicker skin detection.

2008-08-21
(+) New default skin spinner, approachcircle and sliderfollowcircle sprites.
(*) Improved all gameplay stars physics.
(*) Fixed song selection stars getting out of hand with negative offsets.
(*) Flashlight is fixed in position during taiko play.
(*) Nickname match notification in /me works.
(*) Fixed song selection crashes.

2008-08-20
(+) Initial implementation of comboburst.png.  Feedback please.
(+) Added 10/30 score sprites.
(+) Implemented high-res spinner approach circles.
(+) Added two new status icons for top-left display on song select.
(+) Skip sprite supports animation.
(*) Fixed hitcircle/spinner depth problems.
(*) Fixed break results not account for last hitobject before the break in some cases.
(*) Changed 1/8th alert style.
(*) Removed keyboard control from slider bars in most places.
(*) Fixed Bancho searching issues.

2008-08-18
(+) Multiplayer host can be transferred to another player on request.
(+) Multiplayer host is denoted by a crown icon.
(+) Skins can be auto-extracted.  More details to come.
(*) Large changes to song selection screen.
(*) Fixed user options screen not viewable in multiplayer.
(*) Fixed '/r' only working once for PM replies.
(*) Fixed /savelog not saving /me actions.
(*) Fixed private messages not working for usernames containing underscores.
(*) Clicking away from a dropdown closes it.
(*) Starbursts on song selection are in time to beat.
(*) Added approved status to bancho search results.
(*) Various bancho improvements.

2008-08-17
(+) Timing points can inherit previous section's timing - useful for sample/volume changes.
(+) Added personal high score to song selection screen.

2008-08-16
(+) Added four new pack-based achievements.
(*) Fixed achievements not displaying correctly in-game.

2008-08-14
(+) Added new mod "Flashlight", based off adamskii_uk's concept (http://osu.ppy.sh/forum/viewtopic.php?f=15&t=4804).
(+) Added option to disable letterboxing in break time.
(*) Fixed editor allowing hitcircles to be moved off the gamefield at resolutions >640x.
(*) Fixed editor bug where using song select after setting a custom volume in timing points resets volume to 100%.
(*) Generic button middle section expands its width so it no longer needs to be one pixel wide.
(*) Slight graphical changes to default skin.

2008-08-13
(+) Added simple Dropdown UI element.  Can select sort method from it in song selection.
(*) Editor "goto time" popup has text selected by default.
(*) Fixed BSS bug with '#' characters in filenames.
(*) If no replay data is found, the user is not returned to song select rather than the main menu.
(*) Fixed spinner "SPIN!" overlapping "CLEAR!" on shorter spinners.

2008-08-12
(+) Added '/names' command to list all IRC users currently connected to Bancho.
(*) Greatly improved handling of IME input - focus is restricted to IME panel when visible.

2008-08-11
(+) Added 1 new achievement.
(+) Added user menu with some options when clicking users in F9 extended chat view.
(+) Added notification of '/r' command when receiving first PM in in-game chat.
(*) Fixed bug where bottom-right position display shows "1st" even when failing a multiplayer match.
(*) Fixed song select bug where game freezes on trying to hit up/down arrows while no search results are displayed.
(*) Clicking users to specatat them is blocked during an active local play to avoid any misclicks.
(*) Web: Achievements in profile have text hint/description.

2008-08-10
(+) Added estimated time remaining and numerical percentage measurements to BSS upload window.
(*) Fixed grid sizes not displaying correct names in editor.
(*) Fixed skip button acting strangely when clicked then given focus again.
(*) Fixed backgrounds/videos in .osb duplicating into .osu files.

2008-08-07
(*) Fixed source not saving in song setup a well.
(*) Fixed spinner not always giving 'geki'/'katu' bonuses.
(*) Fixed audio not updating when swapping between spectating songs.
(*) Fixed scoreboard losing background graphics after a multiplayer taiko match.
(*) Moved scoreboard during MP taiko games to be more visible.
(*) Changed size of taiko target circle to match small notes.
(*) Made taiko hit-window more lenient (about 40% moreso, depending on difficulty settings).

2008-08-06
(+) Ranking is displayed during break where possible.
(*) SPIN! sprite stays on screen for a bit longer, even if you are spinning.
(*) Improved mp3 preview performance by a lot.
(*) Fixed tags not displaying in the song setup window (although they are saved).
(*) Fixed updater crashes (stuck processes shouldn't happen anymore).
(*) Fixed search results showing incorrect numbers, and multiple difficulties when they shouldn't appear.
(*) Fixed audio lead-in breaking after watching a replay or spectating someone.
(*) Fixed accuracy displaying above pause screen buttons.
(*) Web: Fixed chat feed not showing names with '-' correctly.

2008-08-05
(*) Changes to BSS dialog wording.
(*) Fixed pause button occasionally not working.
(*) Fixed spinning counter-clockwise not triggering CLEAR! sprite.
(*) Fixed overlapping checkboxes in skin selection.
(*) Fixed avatar size issues with multiplayer.

2008-08-04
(+) Added new skin: Xi-Style by Xiaounlimited.
(+) Progressive accuracy is displayed in breaks.
(+) Added option to skin selection screen to choose whether to force Taiko skin during taiko mod play.
(*) Backups of score/beatmap database are made in the case that osu! has to recreate them from scratch.  They will be in your osu! folder.
(*) Added check for hitobjects existing before the start of the mp3.
(*) Removed all scoring elements from Relax mod.
(*) Fixed player status text not displaying properly.

2008-08-03
(+) Added winner panel to multiplayer ranking screen.
(+) Scoreboard in multiplayer displays avatars.
(+) osu! won't exit play mode when receiving a new song (from an Open With... command or drag).
(+) Full Vista support (will run without administrator privileges).
(*) Fixed bancho replying to public messages not prefixed with '!'.
(*) Modifications to SPIN/CLEAR sprites and animations.
(*) SPIN disappears after the player begins spinning.
(*) Fixed some miscellanious crashes when receiving beatmap data (not visible to users).
(*) Huge memory optimisations.
(+) Web: Modding Control Panel initial release. (Echo)

2008-08-02
(+) Added link to profile in BanchoBot !stats/!rank output.
(+) Right mouse button can be used to click buttons.
(+) New timing panel options all work except for "update all difficulties".
(+) Added pause audio button to multiplayer match setup screen.
(+) Added spinner "SPIN!" graphic (spinner-spin.png).  Ask for template (will be added to template skin next release).
(+) Added spinner "CLEAR!" graphic (spinner-clear.png).
(*) Audio tab on timing panel affects multiple timing section selections (volume, sample type etc.)
(*) BSS submissions now allow title and artist changes without breaking the uploaded beatmap.
(*) F12 works on all dialogs (used to be disabled on extended chat, ranking etc.)
(*) Fixed user panel disappearing after song ranking?
(+) Web: Added achievement system with four combo-based achievements.
(+) Web: BSS parses tags and source from osu files.
(+) Web: BSS detects the presence of a video.
(*) Web: Changed references to 'mods' in the Approval Ranking.

2008-08-01
(+) Added "get more skins" button on skin selection panel, which opens osume in the extras tab.
(*) Web: Server performance optimisation.

2008-07-31
(+) Added 'Approved' beatmap status.
(+) osu! support for approved maps.  Displays message on map start to ensure the user is aware.
(*) Removed build number from titlebar of public builds (no longer necessary).  Added on options screen.
(*) Fixed spinner RPM appearing in edit mode.

2008-07-30
(+) Bancho saves activity stats to database.
(+) Added !rank to Bancho.
(*) Taiko strictness (hit-window) tweaks.
(*) Bancho code rewrite.
(*) Database performance fixes.
(+) Web: Added online user count to header (based on currently active osu + irc players).
(*) Web: Huge website performance optimisation.
(*) Web: Leech-protected beatmap download on chigau.

2008-07-29
(+) Added average spinner RPM.
(*) Fixed in-game chat log scrolling down faster than up.
(*) Fixed spacing on audio options screen.
(*) Fixed recovery sound playing when sudden death mod is active.
(*) Fixed multiplayer ranking bug where charts show '>1' when it should show 2.
(*) Removed taiko hitcircle explosion (reduced clutter, more accurate).
(*) Increased timing strictness on Taiko mode (felt way too loose before).
(*) Web: Automatic Bug/Feature forum pruning of completed requests (to subforum).
(*) Web: Changelog fixes.

2008-07-28
(+) Hovering a game name in the multiplayer lobby will show players in that game.
(*) Fixed in-game web links to point to correct locations at new site.
(*) thumbs.db files are automatically deleted from the songs folders.
(+) Web: Added no-video link to beatmap info pages.
(*) Web: Added mod links back to beatmap info page (Echo).
(*) Web: Fixed download links for older maps.
(*) Web: Fixed login tab order.
(*) Web: Long posts are truncated on beatmap info page.

2008-07-27
(*) Web: New website fully deployed!

2008-07-26
(*) Added a few new tips of the day.
(*) Web: New pages, improvements

2008-07-25
(+) Implemented beatmap submission cap.
(*) Bancho fixes.
(*) Web: Huge forum work.

2008-07-24
(*) Fixed "email notification" option in BSS not saving correctly.
(*) Huge bancho bug fixes.

2008-07-23
(+) Bancho remembers channels to recreate when restarted.
(*) Fixed NoVideo mod not taking affect in multiplayer games.
(*) Fixed editor to avoid a full crash when background image/video files are corrupt or otherwise unreadable.
(*) Bancho stability fixes.
(*) Web: Forum styling/integration part 1.

2008-07-22
(*) Fixed spectator mode not working.
(*) Fixed multiple items display on song select (with a slight disadvantage to searching mode, but should be unnoticeable).
(+) Web: Player ranking.

2008-07-21
(+) Taiko mode replays!  Should be totally backwards compatible
(*) Fixed editor button alignment (no longer overlaps chat ticker).
(*) Fixed middle mouse button affecting replay performance.
(*) Improved accuracy of replays when spinners are missed by a fraction of a section (ave. of 7.5 deviation from 60fps, very unlikely).
(*) Ranking screen no longer exits when clicking anywhere (must click back button).

2008-07-20
(*) Fixed bug where inserting background images would occasionally hard crash osu!.
(*) Fixed songs appearing too many times in song selection.

2008-07-17
(+) Added 'Source' metadata field to beatmaps.
(+) Added 'Tags' metadata field to beatmaps.  Can be searched.
(*) Slider click detection code improved further (if you aren't happy with it now, I will slice you).
(*) Counting of search results on song select screen is more sane (counts individual difficulties, rather than sets).
(*) Web: Help pages rewritten.

2008-07-16
(+) Added position/timing lock mode in editor (hotkey: l).  Icon on right-hand side of editor.
(+) New features on timing setup panel, including difficulty propagation, recalc/snap options all available in the one place.  The functionality is not complete yet, so I've just included the new layout so you can take a look.
(+) Added video tutorial links to Song Setup panel.
(*) Some minor graphical changes.
(*) Web: More stuff.

2008-07-15
(+) Taiko combo counter is authentically styled.
(+) Taiko sliders/rolls have hit counter.
(*) Fixed back button animation not getting correct framerate (thus not playing).
(*) Fixed denden countdown on double/half time.
(*) Show chat buttons don't display when skip button is displaying, or when playing offline.
(*) Web: Fixed current level in profile not matching in-game.

2008-07-14
(+) osu! can handle multiple monitors.  When dragging the window to another monitor, the game will force-restart for now.  Last-used monitor is saved to configuration.
(+) Keyboard shortcuts Alt-Left/Right in editor jump to previous/next timing point.
(+) Timing sections display on seekbar as red lines.
(+) Breaks are visible on the seekbar.
(+) Back button supports animation.
(+) Added editor menu option 'File > Open Beatmap Folder (in Explorer)'.
(*) Changed slider slide behaviour - you must hold the button you *began* the slide with.  To swap buttons, you must let go of both buttons then choose your new button.  Lets see how this goes.
(*) Taiko slider velocity multiplier increased to emulate taiko gameplay better with osu! settings.
(*) Fixed beatmap mode option not being stored in local database.
(*) Modified keyboard selection code when changing to a new sort method on song select.

2008-07-11
(+) Added level sorting tab on extended chat.

2008-07-10
(*) Fixed level display being slightly incorrect.
(*) Fixed watching a replay removing maps from unplayed.
(*) Fixed higher ranks with lower scores replacing lower ranks with higher scores on wheel rank display.
(*) F-key shortcuts work even while chat is visible.
(*) Fixed spectator list not clearing on bancho disconnect.
(*) Taiko spin requirement is adjusted according to HalfTime/DoubleTime mods.
(*) Sliders are not converted to hitcircles if map mode is set to taiko-specific.
(*) Reduced taiko rotation requirement.
(*) Taiko skin is only used if it is available.

2008-07-09
(+) Added stacking leniency.
(+) Added taiko-specific map option.
(+) Added in-game notification of nickname changes.
(+) Taiko spinners work like DenDens in Taiko games (count-down).
(+) Added /help and /keys to chat commands.
(*) Changed default bindings to use (Z(X|C)V).
(*) Fixed new online options crashing.
(*) Fixed taiko mod breaking replays
(*) Taiko sliders are sized correctly depending on beat (finish) type.
(*) Can't fail on taiko mod (temporary fix until full taiko scoring is implemented).
(*) Fixed taiko mod displaying "previously set higher score" on ranking screen.

2008-07-08
(+) Added numpad support for per-song offset changes.
(+) Added configuration key to skip tablet initialisations (for people with dll error).  Add 'SkipTablet = 1' to osu!.cfg.
(+) Added in-game video offset adjustment (up to 10 seconds in either direction).
(+) Added online options tab to options screen.
(+) Added toggle for displaying city location on user panel.
(+) Added toggle for displaying notification of people saying your name.
(+) Added panel colours for multiplaying, submitting, afk.
(*) Fixed bug where spinners occasionally do not give geki/katsu hp addition.
(*) Fixed usernames with spaces appearing offline for private messaging.
(*) Fixed possible bancho login-bug (client-side).
(*) Changed taiko alt-2 binding default to d (instead of s).
(*) Changed music fade behaviour after passing a song (fade to 50% and remain at that volume until exiting ranking screen).  Flows a lot better.

2008-07-07
(!) Happy birthday to me.
(*) Fixed spectators not being able to spectate multiplayer.
(*) Fixed score-ki not getting skinned on a per-beatmap basis.
(*) Fixed in-game stars not displaying in some cases.
(*) Fixed bindings being out of order on options screen.
(*) Taiko slider conversion considers repeat sliders as longer in length.

2008-07-06
(+) Added Taiko shortcut from main menu - P-T.
(+) Added per-song custom offset (+/- keys during play mode).
(+) Added key-binding to options dialog.
(*) Local beatmap database is versioned so additions can be made without full repopulation.
(*) Fixed scoreboard displaying a '>' when not necessary.
(*) Improvements to taiko spinner code (must alternate between main/alt, more reasonable scoring?)
(*) Improvements to taiko slider->hitcircle conversion.
(*) Tooltips display when hovering the checkbox as well as the checkbox text.
(*) Fixed taiko sliders displaying hit explosions in random places.
(*) Reorganised options dialog.

2008-07-05
(+) Added level display on user panels in-game.
(*) Taiko flying notes aim themselves at the hp bar.
(+) Web: Added database tracking for beatmap packs (by Echo).
(*) Web: Fixed formatting in new help system.

2008-07-03
(*) Fixed one random crash when in multiplayer match setup (host).
(*) Fixed multiplayer replay export (F2 at ranking screen).  Doesn't have MP scores, just local play.
(*) Fixed Bancho memory leak.
(+) Web: Implemented favourite beatmaps listing.  Primitive support for adding/removing favourites.  Displays totals on song info page.

2008-07-02
(+) Added option to receive email notification on BSS thread replies.
(+) Added new tips of the day.
(*) Fixed beatmap submission where artist field is empty (no "- " before title).
(*) Reverted stacking change to respect replay data.
(+) Web: Added new help page system.

2008-07-01
(*) Fixed case sensitivity problem with tab completion.
(*) Fixed scoreboard total extremity offset being one too high.

2008-06-30
(+) Taiko notes fly~.
(+) Taiko mod converts short sliders to normal hits.
(+) Tab complete lists available usernames if there are more than one, rather than completing the first one.
(*) Fixed taiko drumrolls rendering incorrectly at lower resolutions.

2008-06-29
(*) Taiko slider/rolls work no matter what length, and also look more authentic (no repeat circles and other osu!-specific stuff).
(*) Taiko rolls transition colour depending on drumroll speed.
(*) Minor taiko improvements.
(!) Web server got DDoS'd around GMT+8 1540-1620.  I am looking at this as a randomly targetted attack.  Not too much could be done to restore site access during this period.

2008-06-28
(+) Clicking on timing sections in the timeline jumps to them directly.
(*) Beatmap IDs no longer increase for map updates.  This should save on useless ID increases and make beatmap-specific links last for longer.
(*) Fixed bug with new online data retrieval failing on first osu! load after importing a new song when unmapped songs are present.
(*) Fixed bug with standard submission.  Please reupload any submissions you have (standard submission) if you read this.
(*) Fixed storyboarded intro/outro causing editor to screw up.

2008-06-27
(+) Added taiko 4-button support.
(+) Added taiko drum lights.
(+) Taiko spinning support.
(*) Taiko internal improvements.
(*) Fixed mouse wheel broken in song select when full chat is visible but hidden.
(*) Fixed slider brokenness.
(*) Fixed multiplayer skip not working for outro sections.
(*) Fixed holding down F8/F9 causing constant toggling behaviour.

2008-06-26
(+) Added link to user profile when clicking own user panel.
(*) Search in song select can be activated faster than before.
(*) Fixed bug where search term would be removed when loading a popup dialog.
(*) Fixed more bancho threading problems.
(*) Fixed skipping bug.
(*) Taiko improvements (left/right input, adlib drums).
(+) Web: Added new stats to profile page.
(+) Web: Added play history graph to profile page.

2008-06-25
(+) Added BPM sort mode.
(+) Can export .osr from multiplayer ranking screen (F2).  Experimental support.
(*) Fixed bug where first folder in sort modes doesn't reopen after returning to song select.
(*) Fixed outro samples not playing correctly if the audio has already ended.
(*) Fixed bug where skip button would not fade out in some rare cases.
(*) Fixed stacking not working properly in cases where stacks are over longer durations (Eiji is gone now so I can reduce this "fix")
(*) Fixed text input bugs with test release.
(*) Fixed song selection receiving input when extended chat is visible.
(*) Improved colouring of keybaord selection.
(*) More taiko refactoring.
(*) Fixed some random bancho crashes.

2008-06-24
(*) Fixed offset issue with test build.
(*) Fixed multiplayer channel alignment with hotkey channel selection.
(*) Code refactoring for full taiko mod.  Lots of it.

2008-06-23
(+) New background for ranking screen.
(*) Fixed bug where osu! would sometimes crash at song select when hitting Enter.
(+) Web: Converted frontpage stats and chat to ajax live feeds.
(+) Web: Expanded profile statistics further.
(+) Web: Mod icons shown for song leader.
(+) Web: Added ranked/unranked totals to mapper rankings.
(+) Web: Added scoring section to faq (courtesey of Gemi).

2008-06-22
(+) Added keyboard binding support (config file only for the moment).
(+) Active channel can be swapped using Alt+0-9
(*) Player's ready status won't be changed unless the map or mods are changed.
(*) fixed '/r' or '/reply' also sending to public chat.
(*) Adjustments to ranking screen/score font and panel.
(+) Web: Added two video tutorials to download page.
(*) Web: Adjustments to profile page.

2008-06-21
(+) Highest rank achieved is displayed on song selection wheel.
(*) Fixed bancho bug where channels would not disappear from osu! when revoked.
(*) Fixed chat tabs appearing in the middle of chat.
(*) Fixed players disappearing from extended chat.
(*) Fixed (maybe) unnecessary ping timeouts.
(*) Fixed two random multiplayer crashes (server-side fix).
(*) Changed tab design.
(+) Web: Beatmap listing can be filtered to only unplayed beatmaps.
(+) Web: Added score ratio to player ranking.

2008-06-20
(*) Database transfer.
(*) Minor website tweaks.
(*) Restored profile stats.

2008-06-19
(*) Fixed changing game name causing ready status to be reset.
(*) Fixed bancho threading issues (rewrote a lot of code).
(*) Fixed timezone displaying incorrectly for some users.
(*) Fixed misleading timeline when seeking while paused at <1x speed.
(*) Fixed multiplayer skip bugginess.
(*) Fixed long '/me' lines not displaying properly.

2008-06-18
(*) Moving bancho.
(*) Backup recovery of beatmaps.

2008-06-17
(*) Fixed channel logs not properly clearing when swapping to an empty channel.
(*) Fixed receiving new files at song select.
(*) Fixed storyboarded sounds not playing in intro/outro.
(*) Reduced magnitude of blurring in game transitions (shader effect).

2008-06-16
(*) Reduced bancho thread priority to help combat game lag during communications.
(*) Fixed long chat messages exceeding the screen width.
(*) Fixed new updater threading crashes.
(*) Fixed bug where spectator mode could interfere with multiplayer matches.

2008-06-15
(+) Added per-match chat channels.
(+) Added timestamps to chat.
(+) Added colour coding for multiplaying players.
(+) Added multiple offset adjustment mode to Timing Panel.
(*) Beatmap extraction improved when subfolders are involved.
(*) When opening a folder on song select, the screen now centres on the folder rather than at a random location inside it.
(*) Fixed active tab not coming to front.
(*) Improvements to multiple channel support.
(*) Improved drag detection on song selection screen.

2008-06-14
(+) New song select background for default skin only.
(+) New now playing background graphic.
(+) Added basic multichannel support.
(+) Added match setup sound effects.
(+) Added 'drop mp3 here' graphic.
(+) Added "Selection Options" hover button to song selection screen.
(*) Changed frame limiter default to off.
(*) Changes to test build authentication.
(*) Mousewheel can be used at song select while keyboard selection is active.
(*) Fixed post-game storyboarding.
(*) Fixed .osb load order.
(*) Fixed thread synchronistaion on sprite list.

2008-06-13
(+) Fullscreen resolution can be set independently of windowed resolution.
(+) Fullscreen can be toggled using 'Alt+Enter' from anywhere in-game.
(*) Fixed random crashes during fullscreen/resolution changes.
(*) Fixed skip not displaying for negative times.
(*) Lead-in time is automatically calculated for storyboard events places at negative times (no need to set AudioLeadIn).
(*) Fixed flickering tooltips on fadein.

2008-06-12
(+) Added '/savelog' command to export chat logs.
(+) Added support for multiple comboburst samples (comboburst-0.mp3 etc.)
(+) Updater uses differential updates for the dll file.  Doesn't yet show progress.
(+) Client-side mods can be set on a per-client basis (currently just NoVideo).
(*) Editor controls are no longer operational when the osu! window doesn't have focus.
(*) Fixed audio lead-in for songs with storyboarded intros that start before the mp3 itself.

2008-06-11
(+) Multiplayer matches can perform a skip (all players must request this at the beginning of the song).
(*) More match setup redesign.
(*) Fixed song selection centering on top item of selected group, rather than active difficulty.
(*) Fixed undo states not always saving.

2008-06-10
(+) New match setup scren graphics.
(*) Fixed first slider drawing incorrectly in edit mode.
(*) Fixed bug where songs don't get played when loaded (drag-drop etc.) depending on current sort mode.
(*) Rewrite of netcode to remove all async calls from delegate return (fixes bug experienced by some users see http://osu.ppy.sh/forum/viewtopic.php?f=5&p=27912#p27912).
(*) Fixed text buffer from match setup "game name" selection transferring to song selection search.

2008-06-09
(+) Users can update a beatmap to the latest from the match setup screen.
(+) Notifications are given when a player joins/quits the game.
(+) Added '/r' or '/reply' for quickly replying to a private message conversation.
(*) Random selection button shows up in multiplayer song select.
(*) Fixed bss to submit subdirectories.
(*) Fixed alignment of text buttons on skin selection screen.
(*) Fixed alignment of storyboarded sprites in Design mode.
(*) Reduced blur shader effect on transitions after complaints of it hurting peoples eyes.

2008-06-08
(+) Added UI element TextBox.  Can be seen when changing the name of a multiplayer game as the host on the Match Setup screen.
(+) Double-clicking an .osz file or dragging it into the osu! window while at Match Setup will handle the file without leaving the match.
(+) Player accuracy/rank stats are displayed in match setup.
(*) Combo fire height adjustment slider only displays when combo fire is first enabled.
(*) Fixed audio samples changing to soft set when clicking "Next" on skin selection page.
(*) Fixed search box text input focus being lost after clicking on a score to watch the replay.
(*) Fixed slider dodginess (recalculations happening too often).
(*) Changed way IRC users are displayed to allow for more chat log lines.

2008-06-07
(+) osu! will disable the windows screensaver while it has focus.
(+) Window title flashes when the local player's name is mentioned and the window doesn't have focus or is minimised.
(+) Added slider curve type shortcut keys 'A' for linear, 'S' for catmull, 'D' for bezier.
(+) Added alerts for certain editor mode changes.
(+) Added 'Folder' sort mode for song select.
(*) Remapped distance spacing hotkey to 'T' in compose mode.
(*) Failing players are sent to the bottom of the scoreboard (where they can compete with other failed/quit players.
(*) Fixed accuracy/playcount sorting causing conflicts with players that had the same stats.
(*) Rewrite of stat update packets to ensure higher reliability.
(*) Fixed some cases where sliders don't display in editor properly.

2008-06-05
(*) Multiplayer games cannot start without at least two players.
(*) Username case is corrected at login/game start.
(*) Removed dependency on System.Web.
(*) Fixed crashing on cancelling BSS uploads.
(!) Fixed forum issues.

2008-06-04
(*) Fixed random null errors.
(*) Multiplayer crashes fixed.
(*) Multiplayer ghost players and games fixed.
(!) Dealt with database table disappearing 3 times??

2008-06-03
(+) Added skinnable sound effect (comboburst.wav).  Activates on starbursts.  No default skin sound yet!
(*) Fixed wonky spinner alignment.
(*) Fixed user panel not changing to correct colour.
(*) Configuration file is alphabetically ordered.
(*) Song load time decreased by ~10%.
(*) Sorting in lobby improved.
(*) Multiplayer bugfixes.

2008-06-02
(+) Multiplayer ranking screen implemented.
(+) Players can continue playing after a fail in multiplayer.
(+) Multiplayer start/end of game is synched.
(+) Players without a beatmap will be marked, and have the option to download the map in the match setup.
(*) Fixed "Other Spectators" list not display (why did noone pick up on this!)
(*) Fixed mouse cursor not reappearing if exiting spectator mode by clicking your own avatar while watching.
(*) Refactor of multiplayer packet structure.
(*) Fixed main menu buttons getting hover focus under the osu! logo.

2008-06-01
(+) Scoreboard appears even if scores are not loaded at song selection (ie. if you were on local ranking).
(+) Added on-screen message when using main-menu hotkeys to change audio status.
(*) Added skin.ini variable "CursorTrailRotate".  If this is set to 1, the cursor trail rotation rotates with the cursor.
(*) Scrollbars are disabled when scrolling is not possible.
(*) Fixed sliderbars getting modified even when window is not in focus.
(*) Bancho only compresses data when it exceeds a fixed size (512bytes).
(*) Lobby improvements - new layout and better stability.
(*) Multiplayer play improvements and bugfixes.
(*) Fixed sort order of scoreboard.
(*) Fixed sort order of users with rank sorting.

2008-05-31
(*) Fixed editor saving .osb contents to .osu files.
(*) Fixed bug where video event lines are removed by the editor.
(*) Mouse wheel can have focus in editor/song selection even when F8 chat is visible.
(*) Multiplayer song selection can be changed.
(*) Chat window is hidden when a popup dialog is activated.
(*) Entering lobby doesn't screw with mousewheel focus.
(*) General lobby/multiplayer improvements.

2008-05-29
(+) Added blur when dialogs are visible (mod select etc.) (Shader effect).
(*) Fixed bug with exporting replays when song contains invalid windows filename characters.
(*) Reduced LZMA compression dictionary size to fix out of memory errors on some PCs.
(*) Updated LZMA libraries (performance improvements).
(*) Fixed random crash when ending slider placement of an invalid slider (too short).
(*) Fixed random crash bug when creating sliders in editor.
(*) Fixed some custom samples not loading on a beatmap level (sectionpass etc.)
(*) Fixed 'Perfect' graphic not displaying.
(*) Reduced bancho bandwidth usage by >80%.
(*) More netcode changes.
(+) Web: Added option for mods to delete beatmaps.  Threads will not be deleted - please handle these manually.

2008-05-28
(*) Fixed crash when selecting a song selection tab that contains 0 items.
(*) When a timing inconsistency is detected, the current play will not be ranked, but the game will not crash.
(*) Fixed osu! chat support with new multichannel changes (no multichannel support yet).

2008-05-27
(+) Added lighting flood when spinner hits bonus levels (Shader effect).
(+) Added blur when HP hits dangerous levels (Shader effect).
(+) Added lighting burst with star bursts (Shader effect).
(+) Added skin.ini variable "AnimationFramerate".  Defaults to playing all available frames per second.  Applies to all animated sprites except spinner ball.
(+) osu! will give the option to force-kill other copies of osu! if it detects there is another copy running.  Useful for hanging processes.
(+) Added multichannel support for external IRC clients (yay!) (Echo)
(*) Local scores for beatmaps which have been deleted will be removed from the database.
(*) Fixed bug where osu! may crash when saving a score.
(*) Reduced softening filter by 25%.
(*) Increased leniance with audio drift checking.  Seems to be a lot of false positives currently.
(*) Fixed songs being selected through the osu! button on song select.
(*) Hitting escape to return to previous menu from options makes a sound as expected.
(*) Clicking songs on song select is easier (larger radius allowance, less restrictions in general).
(*) Taiko mode is MARKED AS UNRANKED.  A lot of people asked this question...
(*) Fixed pause status being set incorrectly.
(*) Fixed minimising osu! window over a long period of time causing unresponsiveness on restore.
(*) Fixed minimising osu! window causing random crashes.
(*) Scoreboard names are cut off with an ellipsis when they are too long to fit

2008-05-26
(+) Added generic shader addon support with bloom/softening filter.
(+) followpoint and followcircle are animated.
(+) Mouse "back" button (mouse4) performs the same action as hitting 'Escape' on the keyboard.
(*) Fixed bug where clicking the osu! button on song select quickly after loading causes weird animation glitch.
(*) Score submissions are attempted again if they fail the first time around.
(*) Fixed 'Force tablet initialization' not actually having any effect.
(*) Fixed 'Unranked maps' filter not remembering its toggle state.
(*) Large refactoring of sprite management.
(*) Lobby bugfixes.

2008-05-25
(+) Added applause sound for default skin (this will be improved in the future).
(+) Added combofail sound for default skin.
(+) Added "unranked only" filter.  Any suggestions on where to put these checkboxes?  They feel like they are floating in the middle of nowhere.
(+) Added skin.ini variable "SpinnerNoBlink".  Defaults to 0.  When set to 1, it will stop spinners from "blinking" the top of the metre as they rise/peak.
(+) Added single-display help popup system.
(+) "failsound.wav/mp3" is now skinnable.
(+) osu! attempts to solve the scenario where a users *extracts* the contents of an osz file (usually IE users) to the songs directory (without encapsulating it in a subdirectory).  It will also warn the user.
(+) Bancho user sort mode is remembered between startups.
(*) Skinnable sounds now load with a .wav OR .mp3 extension.  Please use wav files for hit sounds or anything that loops.
(*) Selected song on song select is bold.
(*) fail-background is correct resolution.
(*) Fixed Alt/F10 freezing the osu! window in some cases.
(*) Song list can be dragged during keyboard selection.
(*) Importing beatmaps while in edit mode selects them as expected.
(*) Applause sound stops when exiting ranking screen.
(*) Audio samples are cached at song load rather than when the sampleset changes.  Should fix freezes in some songs which use custom samples.

2008-05-24
(+) BSS progress bar actually shows upload progress.
(+) Added skinnable element: fail-background.png 640x480 aligned from (0,0) topleft.  Displays on fail screen above the black background, below the buttons.
(+) scorebar-colour can be animated (scorebar-colour-0, scorebar-colour-1 etc.). Will play frames over 1 second for a full cycle.
(*) New HTTP implementation.  This should hopefully solve problems with logging in/uploading maps for those few people out there!
(*) osu!me uses new http code.  Should no longer crash randomly.
(*) BSS will not accept uploads with non-ascii range characters in their metadata.
(*) BSS allows aborting of file upload (when clicking cancel).  Before, the file would continue to upload in the background.
(*) Fixed crash when hitting tab during a level with no scoreboard.
(*) Changes to song selection rotation physics.  Hold left mouse button to drag, hold right mouse button to fly
(*) Song list scrolls when mouse is near top or bottom.

2008-05-23
(+) Basic multiplayer implementation.
(*) Scoreboard has cooler effects.
(*) Fixed crash with timing panel popup when deleting existing points.

2008-05-22
(*) Partwise slider points can be moved after placement as expected.
(*) Scoreboard improvements and fixes.
(*) Scoreboard can be toggled with Tab.
(*) Skip button doesn't appear after passing a map unless there is extended storyboarding.
(*) Can start matches from lobby (no sync/scores yet).  But seriously, don't try this :).
(*) BSS bbcode problems fixed (thanks to Echo).

2008-05-21
(+) Added in-play scoreboard.
(*) Fixed sliderbar bugginess.
(*) Fixed a few minor bugs.

2008-05-20
(+) !faq command is customisable, allowing adding new entries and listing available entries.
(+) Added bancho status 'Afk' (away from keyboard).  Activates after 2.5minutes of inactivity.
(+) Added bancho status 'Paused'.  Should help determine who is actually *playing*.
(+) Added skin.ini variable "SpinnerFrequencyModulate".  Defaults to 1.  When set to 0 the spinner sound will not increase in frequency.
(+) Added skin.ini variable "SpinnerFadePlayfield".  Defaults to 1.   Fades the playfield to black during spinners.
(+) Added skin.ini variable "LayeredHitSounds".  Defaults to 1.  When set to 0, whistle/finish hits will NOT play the normal sample layer.
(*) Screenshot file number is stored in config file (very marginal performance increase when taking screenshots).
(*) Lobby improvements.

2008-05-19
(+) No-video links are added by bss.
(+) Can seek to a time in the editor by clicking the time display.  Accepts full formatting [00:01:55 (0,1,2,3)].
(*) Hyperlinked time seeks in chat are recognised at any position in a chat line (rather than only at the start).
(*) Fixed sort order of video events to always be in front of background events.
(*) Clicks during audio lead-in are handled correctly.
(*) Turned off sorting of storyboard events on editor save.  Let's see how this behaves!
(*) Slider minimum length restrictions added back in.  I think this is quite a good one to have so we don't get broken sliders.

2008-05-18
(+) In-game buttons use a skinnable template.
(+) Spectators can see other players which are watching
(+) Name of player being watched is displayed in user panels.
(+) Piecewise slider composition.
(*) Adding new points to an existing slider is a lot more reliable.
(*) Changed way web menu handles enabled status.
(*) Fixed occasional crash when ending spectator mode.
(*) More lobby work.

2008-05-17
(+) First test release of multiplayer lobby.
(*) Fixed mouse cursor rotation when swapping to a skin that doesn't use rotation.
(*) When exiting spectator mode, control is given to main menu rather than song select.
(*) Fixed Y alignment of score-Ki at different resolutions.
(*) Fixed mouse cursor weirdness after spec/replay.

2008-05-16
(*) Lobby improvements.

2008-05-15
(*) Lobby improvements.

2008-05-14
(+) Added beatmap length filter.
(*) Nickname highlight is case insensitive.
(*) Reduced number of quit/join messages for cycling osu! clients.
(*) Fixed ping timeouts for irc ghosts.
(*) Fixed accuracy formula (wasn't weighting enough).
(*) Fixed sliderbar in editor displaying when it shouldn't be (design/timing modes).
(*) Lobby and match backend nearing a usable state.

2008-05-13
(+) Added !faq command.
(*) Fixed sliderbar lines not appearing at some resolutions.
(*) Fixed hp bar extending beyond its bounds.
(*) Fixed spinner bonus text disappearing in one scenario.
(*) Fixed spinner bonus text changing size depending on hitcircle size.
(*) More lobby backend work.

2008-05-12
(+) All osz/zip files are checked as to whether they have a read-only flag, and if so, this flag is removed before extracting.
(*) Changed approach circle depth ordering.
(*) More lobby work.
(*) Bancho memory fixes.

2008-05-11
(+) F1-F6 keys and Z-V (winamp style) keys work on main menu for controlling music playback.
(+) /np (now playing) now works even when not playing a beatmap.
(*) Fixed replay data not being exported correctly if local score is not saved.
(*) Changed way slider bars are handled internally.
(*) Added option to adjust combo fire height/thickness.
(*) Fixed bug where taking a screenshot would crash osu!.
(*) Fixed taiko mode crashing skin selection.
(*) Fixed audio offset sliderbar unpausing music if it is paused when hovering.
(*) Editor deselects any timeline selection when entering the playfield in non-select mode.
(*) More work on backend for multiplayer lobby/game structure.  Not yet functional, but getting close.

2008-05-10
(+) Start of what will be the multiplayer lobby.
(*) Fixed events not necessarily prolonging the end of a beatmap (outro use).
(*) Fixed certain internal fixes (ask if you think you need to know).
(*) Internal code changes moving towards multiplayer vs support.
(*) Better error handling when files are in use when a move/copy operation is attempted.

2008-05-09
(*) Fixed copying in editor with no notes selected causing a crash.
(*) Fixed spectator mode not loading ranking screen correctly (score calculation error).
(*) Fixed replay/ranked filters not working as expected.

2008-05-08
(+) Editor selection links can be clicked in chat!
(+) Converted unplayed tab to checkbox filter which works in all sort modes.
(+) Spectating scores are fully sync'd!
(*) Editor clipboard time refers to the *first object* in selection.
(*) Taking a screenshot pops up a notification of the filename.
(*) Taiko mod general improvements (less broken slider elements).
(*) Fixed pause menu buttons not working while mouse buttons are disabled.
(*) Fixed sliders in replays being affected by clicking.
(*) Fixed skinned mod icons not skinning on ranking screen.

2008-05-07
(+) Added new mod icons by LuigiHann (thanks yet again).
(*) Fixed replay control buttons not being clickable during spinner/slider.
(*) Better handling of circles and sliders in taiko mod.
(*) Player code changes.
(*) More work on multiplayer backend code.
(*) Outro can be skipped.
(*) Fixed broken spectator mode.

2008-05-06
(+) Preliminary taiko mod (feasibility?).  Hit F4 at song selection.
(*) Another (hopeful) fix for user panel movement.  Its a pity I can't replicate this ;(.

2008-05-05
(+) Internal handling of score frames, for mid-way spectator/mp.  Not yet fully functional.
(*) More fixes to user panel movement.
(*) Fix for lag when playing offline.

2008-05-04
(+) Added support for .osb external difficulty-independant storyboards.
(+) Added option to make storyboard layers 1-3 draw in front of combo fire (StoryFireInFront:0 under [General] in .osu file).
(*) Login dialog handles connection errors better (and allows cancelling at all times).
(*) Extended chat should be less broken with transitions (please report if there are still problems with separation of sprites).
(*) Optimisation to hitcircle handling internally.
(*) Fixed some unnecessary saving in editor when both a background image and video are included in a map.
(*) Accuracy on extended chat is always 2DP.
(*) Game fades out slower when exiting.

2008-05-01
(+) osu! offline installer is complete and available for testing.  Automatically handles .NET prerequisites.
(+) Added checkboxes for online privacy options (not yet implemented).
(+) Added millisecond and x/y coordinate display in design mode.  Handy for scripting.
(*) Slider recalculations are reduced in editor.
(*) Fixed bug with high spinner tick rates displaying incorrectly in design view or after changing timing settings.
(*) Fixed bug where slider ticks sometimes briefly appear (for one frame) as they are fading out.
(*) Fixed skipping possible with spacebar even when skip doesn't do anything.
(*) Fixed universal offset setting audible even when osu! is not focussed.
(*) Fixed exporting online replays to a file (didn't work before).
(*) Changed storyboarding so katsu combos trigger the failing sequence.
(*) Hopefully fixed user screen sometimes leaving users misaligned.

2008-04-30
(+) Private message support in chat '/msg <user> <message>'.
(*) Fixed buttons not working in spectator/replay mode.
(*) All in-game authentication is handled by bancho - no longer requires any http calls.
(*) Performance improvement for rendering text sprites which are of length zero.

2008-04-29
(*) Fixed slider curve-type not being remembered correctly througout a single osu! session.
(*) Fixed bug with chat visibility in offline mode.
(*) Fixed mouse handling in replay mode (clicks being picked up by replay playback).

2008-04-28
(*) Fixed mouse sensitivity over 2x not being saved correctly.
(*) Fixed tablet initialisation on a system not supporting it causing failure to open osu! on future attempts.

2008-04-27
(*) Added now playing messages back in, but triggered by user command '/np'.
(*) Mouse velocity should be a lot smoother - allows for decimal measuresments. (revoked for public)
(*) Changed order of hitcircle/slider explosions - not sure why they were being ordered opposite.
(*) Fixed dragging starting before mouse cursor is moved after clicking.
(*) Fixed slider issues (copy/paste sprite clones).
(*) Fixed sound of spinner bonus not being affected by per-beatmap sample volume.

2008-04-26
(+) Points required until next rank added to ranking screen.
(+) New storyboard transformation type 'V' - vector scale.  Works like M but accepts width and height parameters for scaling a sprite, rather than movement.
(*) Full level play optimisations are in.  Approximately 18x speed boost.
(*) Fixed bug with parameter type storyboarding events.
(*) Fixed avatar not updating when changing active user.
(*) Fixed chat not closing correctly if it was open when logging off.
(*) Sliders no longer save their first point in the .osu file.  Slight optimisation.
(*) Moving sliders in editor (non-point editing) is around 95% faster.
(*) Fixed tabs on chat window disappearing when swapping skins.
(*) osu! only allows one instance running at all times.

2008-04-25
(*) Play mode optimisations.  CPU usage drops as progress is made in a beatmap.
(*) Fixed problems with slider placement in editor.
(*) Fixed tab draw depth problems.
(*) Fixed misalignment of users screen when in editor.
(*) Slider optimisations.

2008-04-24
(+) Added force tablet support option.
(*) Play mode optimisations.  Some areas of code have improved in efficiency by up to 99.97%.  Parapara should be getting faster :P.
(*) Fixed (avoided) cryptographical crash when xfire is running.  Let's see how this behaves.

2008-04-23
(*) Fixed audible delay on default skin's soft-hitfinish sample.  Won't update testing release just yet.
(*) Fixed misalignment of users window when in editor.
(*) Internal data structure changes.  Tell me if anything stops working!

2008-04-22
(*) Fixed bug with window height in configuration file resulting in wacky slider drawing.	

2008-04-21
(+) User list custom sorting.
(*) Stat change notifications slide with their respective users.
(*) Improved accuracy of nickname highlights.
(*) Fixed bug where beatmap doesnt end when a spinner/note occurs after the audio finishes.  Of course, if this happens you will FAIL the map.  Let's try not to do stupid things like this, ok mappers?
(*) Chat ticker displays fully in editor instead of ticking, but appears above the bottom toolbar.
(*) Fixed bug where update window causes pause menu to not work if it is triggered during gameplay.

2008-04-20
(+) Users fade in/out when joining/quitting.
(+) Added mousewheel scrolling to user list.
(*) Special coloured rank numbers for top 10.
(*) Ranked-only checkbox status is remembered throughout a session.
(*) Toggles to the right of the editor (GridSnap, DistSnap etc.) are remembered throughout a session.
(*) Added option to unlimit fps back in for testing.
(*) Removed saving of audio checksum to beatmap files (wasn't being used, and I don't see a need for it).
(*) Fixed editor asking to save every time (with storyboarded maps).
(*) Fixed rank conflict situations on bancho user listing.
(*) Fixed ranking dialog appearing in gameplay if retry is pressed rapidly after reaching the ranking dialog.
(*) Fixed smoothness of song select with framerate limit disabled.
(*) Abstraction of TabCollection.  Will be used for sorting the userlist (and maybe as a pagination system for options screens?).

2008-04-19
(+) Added notification when you name is said in chat when chat is not open.
(+) User panels slide around.
(+) Added option in song select to reset local scores for a particular beatmap.
(+) Beatmap submission status is displayed in editor song select.  Updating functionality is also present.
(*) Scroll lock key is blocked (xfire shortcut key).
(*) Changed 'Clear unplayed list' option to 'Remove current beatmap from unplayed'.
(*) Fixed tab not working in chat while in edit mode.
(*) Fixed scrollbar exceeding maximum scroll when content area shrinks.
(*) Converted all default skin sound samples to wav.  Removed silence-cutting from ALL mp3 samples.
(*) Skin template brought up-to-date.

2008-04-18
(+) Added highlight when your name is said.
(*) Fixed test mode not functioning correctly.
(*) Fixed local replays causing a crash.
(*) Fixed bug with spectator when a watcher starts, ends, then starts watching the same player again.
(*) More investigation into bancho crashes, hopefully some resolution? :/

2008-04-17
(+) Added skin option "HitCircleOverlayAboveNumber".  Defaults to 1.
(*) More bancho deadlock fixes.
(*) Fixed bug where osu! would crash on some systems when trying to open a webpage by clicking an in-game link.
(*) Fixed bug where osu! would not start if registry access was not available.
(*) Fixed update dialog appearing many times.  Now only appears once per application start.
(*) Fixed osu! trying to reconnect to bancho after a version mismatch.  Only tries once now.
(*) Fixed cursor trail draw depth being above the cursor itself during play.
(*) Fixed editor crashes when placing a slider, and clicking an already placed point to remove/re-place it.
(*) Fixed occasional crash when deleting beatmaps.
(*) Improved streaming syncing.
(*) Improvements to slider rendering.

2008-04-16
(!) Public release.
(+) User panels colour depending on play mode.
(*) Decreased fade times on user panel swaps.  Fixed a few display issues.
(*) Fixed mouse speed requiring a restart.
(*) Fixed random crashes on song selection (reported by MusicFan).
(*) Fixed spinner problems.
(*) Fixed editor not allowing saving of a map when an exception occurs.
(*) Fixed thread deadlocking on bancho (not in the best way possible, but it should avoid crashes for now).
(*) Improved error reporting.

2008-04-15
(!) Public release.
(+) Show chat button added.
(*) Fixed drag selection dodginess in editor.
(*) Fixed update bar appearing in edit/play modes if it takes too long to display.
(*) Deleting a beatmap with only one difficulty will remove it totally from disk, no options.
(*) Modified error dialog.  Automatically redirects to PS1.1 website when required.
(*) Fixed search not working on some rare occasions.
(*) Login dialog doesn't show cancel when its not necesssary.
(*) Fixed spectator crashes.

2008-04-14
(+) Added editor speedup flag (disables undo/redo).  Add 'FastEditor = 1' to osu!.cfg
(+) Bancho automatically submits error reports to peppy.
(+) Chat ticker can be toggled.
(*) Spectator support enhanced.  Almost back to where we were!
(*) Spectator list returns.
(*) UI graphical changes (mostly editor).
(*) Shortcut keys for menu items work correctly depending on the current tier.

2008-04-13
(+) Added LuigiHann's three skin updates to test updater.
(+) Added tooltips to options.
(+) Added displaying of city/country in F9 panel.
(*) Fixed random crash when playing back a saved replay.
(*) Fixed display order of spinners.  Now should appear underneath all hitcircles.
(*) Rewrite of configuration manager.
(*) Increased ping timeout delay on osu!'s end.  Bancho sends multiple ping requests when none are received.
(*) Bancho compression algorithm changed to bzip2 - .net gzip library is shit.
(*) Fixed bug where clicking on 'solo' too quickly would take you to edit mode.
(*) Changed the way mouse trails are displayed.  Should look smoother.
(*) Spectator improvements (functionality-wise... it still doesn't work :)

2008-04-12
(!) Fixed the problems with replays - you guys should be safe to rank in songs again using test version.
(+) Nickname tab completion support in chat mode.
(*) Chat log word wrap is more sensible.
(*) Chat control buttons fade when they would oherwise be hiding text.
(*) Status updates only sent to bancho when they actually change to a different status.
(*) Fixed replay playback bugs on slow conections.
(*) Fixed occasional crash when closing the ranking screen.
(*) Fixed crashes in editor when changing bpm/offset before setting a timing section.
(*) Fixed replays not recording all important frames with new code.
(*) Fixed approach circles fighting for depth buffer ownership.

2008-04-11
(*) Improvements on game smoothness, mouse cursor responsiveness, overall performance (internal change to frame limiting).
(*) Fixed dual monitor support (dragging between monitors caused a crash).

2008-04-10
(+) 'Submitting' status added. 
(+) Mod icons are skinnable (see feature reqs. board for pre-rls details)
(+) Local time is displayed on user panels.
(+) Spectator reimplementation (bancho-based).
(*) Fixed panel display bugs.
(*) Default skin improvements (minor, dll tomorrow).

2008-04-09
(*) www. links are also handled by the chat window.
(*) Chat text is word-wrapped more intuitively (fills up the whole window now).
(*) Scrollbar behaves a lot more like a scrollbar.
(*) Fixed dodgy fading errors on user panel.
(*) Fixed bancho crashing.
(*) Fixed sprite alignment.

2008-04-08
(+) 'Z' key in editor bound to 'Stop'.
(+) Scrollable UI elements implemented!
(*) Fixed rendering of slider borders when they are not black or white.
(*) Fixed display bugs with new user panels.
(*) Bancho handles guest logins (offline mode) and user changes.
(*) Fixed syncing of slower playback speeds in editor (<1x)
(*) Chat won't automatically scroll when reading through back buffer.

2008-04-07
(+) New player dialogs.
(+) Realtime statistics feed.
(+) Player activities are viewable on F9 screen.
(*) Fixed overlap spacing for skinnable fonts.
(*) Improved general draw performance by ~20-40% depending on number of hitcircles places.
(*) Fixed bug where clicking replay on ranking screen without saving a local replay causes an error.
(*) Can no longer trigger an unpause when failing (cosmetic only).
(*) Bancho network layer rewrite from scratch.

2008-04-06
(+) Score-specific font added to default skin (tomorrow for test build).
(+) Implemented osu! IRC with support for user stats.  Spectator mode is not yet complete.
(*) Removed all IRC support from osu!.
(*) Fixed middle mouse button affecting replay playback.

2008-04-05
(*) Hitting enter on an in-game popup dialog will close it.
(*) Bancho improvements.

2008-04-04
(+) BPM changes on timing screen can automatically adjust placed circles.zz
(+) Different fonts can be assigned to score and hitcircles.
(+) Font overlap (spacing between characters) can be specified.
(+) HP graph is visible on the result screen after watching a replay/spectating.
(+) Select in-game dialog buttons using number keys.
(*) A few updated editor graphics.
(*) Editor timeline hitcircles move a lot more smoothly.
(*) Fixed bug where game crashes on watching replay.
(*) Fixed black level on slider numbers.
(*) Fixed combo counter not fading in/out correctly.
(*) Background behind spinners fades to black during spinning.

2008-04-03
(*) More graphical improvements in editor.
(*) Play mode plays until the end of storyboarded content (I hope - haven't tested this.  There is no skip button yet, but escape works).

2008-04-02
(+) Fonts are skinnable!
(+) Added "now playing" display button to main menu.
(*) New editor buttons (thanks to LuigiHann again for beautiful icons!)
(*) Lots more tidying of buttons/graphics.

2008-04-01
(+) Fully recoded main menu with new button graphics, with icons kudos to LuigiHann.
(+) Option to toggle skin samples on/off.
(+) Speed of countdown can be halved or doubled.
(*) Sharp corners on sliders look silky smooth.
(*) Fixed automatic moving of notes when changing offset (used to affect ALL previous timing sections).
(*) Fixed bug with hp graph sometimes not saving.
(*) Fixed bug with <4 combo colours not saving correctly.

2008-03-31
(*) Offset slider no longer starts playing music if music was paused on hover.
(*) Reverted old mouse sensitivity code until I have time to fix the new stuff.

2008-03-30
(+) Added menu tiering to main menu.  Placeholder buttons.
(*) Removed unintended gradient on hp graph.
(*) Fixed slider alpha problem.  Bow down before me luigi.
(*) Fixed crash with manual timing setup window when deleting all sections then adding one.
(*) Mouse sensitivity doesn't affect editor.
(*) Rewrote mouse sensitivity calculations.  Should be a lot smoother (more noticeable the higher your setting).
(*) Local score database is saved on closing osu!, rather than at each song completion.
(*) Bancho<->osu! performance doubled.

2008-03-29
(+) Sliders snake in.
(+) Independent SS and SH sprites added (with skinning support).
(+) Bancho pings client and handles timeouts.  osu! connections support silent reconnections, meaning ghosts are a thing of the past.
(*) Sliders look much cleaner - new border and gradient rendering.
(*) Slider endpoints don't change opacity.
(+) When copying notes (Ctrl+C or editor menu), the clipboard will contain the current time location and combo numbers of selected notes (MODS USE THIS!!).
(*) Automatic note adjustment when changing offset defaults to ON.
(*) Non-combo per-beatmap custom colours are loaded and saved correctly by the editor.  Restructured how colours are cached internally to be more clear.

2008-03-28
(+) Xfire compatibility/support added.
(*) When running in fullscreen, osu! will swap to windowed mode at the Edit song selection screen, rather than the editor itself.
(*) Fixed stats not updating correctly via Bancho on completing a song.
(*) Bancho bug fixes and general improvements.
(*) osu! automatically maintains connection to bancho.

2008-03-27
(+) osu! connects to bancho irc via custom protocol.
(*) Bancho infrastructure improvements.

2008-03-26
(+) Bancho client in osu!.
(+) User stats (own only) are received from bancho.
(*) Bancho client handles timeouts.
(*) Bancho server improvements.
(*) Fixed sliders not fully disappearing when deleting.

2008-03-25
(+) Bancho has better irc support.
(+) Bancho can send compressed osu! statistics objects.
(*) Fixed random crashing at main menu/song selection.
(*) Fixed crash when deleting timing sections.
(*) Fixed crash when clicking random song.

2008-03-24
(+) Project osu!Bancho is underway!
(+) Offset changes can be automatically reflected in hitobjects.
(+) Holding 'Ctrl' while changing bpm/offset doubles the precision.
(*) Save local replay status is remembered.
(*) Timing buttons in editor are more responsive to single clicks.
(*) Improved performance when moving large selections in editor.
(*) Slider calculation is 91% FASTER.  On a 30 minutes beatmap (hi chan) this reduced load time from 35seconds to 3.

2008-03-23
(*) Realised my silence finding function WASN'T RUNNING!  Fixed, and adjusted previous beatmaps to earn themselves a free 25ms offset.
(*) Show active mods on song selection screen.
(*) Fixed rating stars sometimes not appearing.
(*) Fixed bug with spinners spinning funny during relax recovery.
(*) Fixed seeking in editor when paused/stopped (used to jump around).
(*) Fixed score maintenance popup not appearing in fullscreen.
(*) Fixed "Break" not displaying in editor timeline.
(*) Misc storyboarding fixes.  Hmm, I really want to do some more work on the scripting syntax... it pisses me off atm!

2008-03-22
(+) Added echostars in test mode.
(*) Fixed animation of slider hitcircles (reverse arrow didn't fade correctly).
(*) Fixed spinner playback in replays.

2008-03-21
(+) osu! accepts .osr files, and imports then to local ranking.
(+) Added hit accuracy statistics in test mode.  Should be useful for calculating incorrect offsets.
(*) When dragging files into osu! in edit mode, you will be prompted to save current work before the editor exits.
(*) Receiving files by drag-drop or association handled a lot better.
(*) All samples in-game are checked for silence.  Should help a lot with offset/latency issues.
(*) Fixed grid snapping menu item not updating its ticked status.
(*) Countdown now halves in speed with songs over 180bpm (previously 240bpm+).
(*) Menu button graphics changed again.

2008-03-19
(+) Save replays by hitting F2 at ranking screen.  Don't try playing them back yet.
(+) Added % buffered when spectating.
(*) Fixed index bug when deleting songs.
(*) Fixed bug with local usernames capturing unnecessary keystrokes.
(*) Fixed bug where irc crashes on very long lines of text.
(*) Local scores database much more efficient.  Filesize down 80%, and about 90% faster to load and update.

2008-03-18
(+) Added small versions of ranking sprites.  Look a lot better on song select.  Skin using "ranking-A-small.png" etc.
(*) Mouse cursor doesn't respond to buttons when outside the osu! window.
(*) osu! default skin revamp.  Lots of changes to make things look generally cleaner.
(*) Applause only plays when entering the ranking screen from play mode.
(*) Fixed stanza counter not updating properly.
(*) Editor mode fully uses new text renderer.  No longer using the old one anywhere in osu!.
(*) BPM changes cache slider redraw (less lag when changing BPM).

2008-03-17
(+) Online ranking position displayed on new ranking popup.
(+) Changes in accuracy/ranked score/rank position display on user info panel.
(*) Fixed crash bug with new ranking display.
(*) Fixed crash when trying to watch a replay that hasn't been saved.
(*) Fixed random retry crash bug.
(*) Fixed applause playing on combo break.
(*) Combo break sound doesn't play during relax mode, and only plays if you have a combo over 20.
(*) Accuracy is weighted depending on the total number of notes hit/missed per-play.

2008-03-16
(+) Added view ranking link when clicking profile.
(+) Reoutfit for ranking popup dialogs.
(*) Ability to choose whether to save local replays or not.
(*) New skin loading code.
(*) Fix for search not working.
(*) Fixed score on song selection not updating if submission takes too long.
(*) Increased efficiency of text measuring.
(*) IRC text selection and cursor look a lot better.
(*) Skin selection shows full skin names.

2008-03-15
(+) Links in chat are clickable.
(*) Fixed problem with saving animation types in storyboarding.
(*) Changed shortcut key for delete bookmark to ctrl-g.
(*) Fixed bug when searching and using keyboard selection.
(*) Fixed spinner not spinning in timing mode of editor.

2008-03-14
(+) Added ability to delete specific difficulties rather than all.
(+) Added reset button to mod selection screen.
(+) Added skinning support for sound effect when breaking a combo (combobreak.wav).
(+) Added skinning support for applause sound on ranking screen (applause.wav).
(+) Added ability to change the colour of the approach circle on spinners (SpinnerApproachCircle in skin.ini).
(+) Added skinning support for ranking letters and other rank screen elements.  See skinning request thread for more details.
(*) Fixed metronome timing a bit.
(*) Fixed hit sounds playing in timing mode.
(*) Fixed bug with storyboard (Parameter type transformations in a loop didn't save correctly).
(*) Fixed bug where minimizing osu! with a slider visible on-screen would cause a crash on restoring.
(*) Skin selection scorebar lines up properly.
(*) Greatly improved text render quality at 640x480 and 800x600.
(*) Chat window now uses new text renderer.  Two more lines of log visible.
(*) Huge optimisations to searching at song selection.

2008-03-13
(+) Skin selection screen.  Finally.  Could do with some more refining, but seems to work quite well for its purpose.
(+) Added option to disable mouse buttons in gameplay.
(*) Fixed random crash when undoing a slider placement in editor.

2008-03-12
(+) Web links accessible from editor.
(*) In-game dialogs can be queued.  Replaced a couple of awkwards winform popups with ingame dialogs.
(*) Fixed bug where custom sample override checkbox would not be saved correctly on song setup screen.
(*) Fixed ranked status/ids not being updated.
(*) Fixed background video checkbox not updating in options.
(*) More code reorganising.

2008-03-11
(+) Added option to disable mouse wheel controls in gameplay (volume/pause).
(+) In-game links to beatmap thread/info pages.
(+) Added mod HalfTime.
(+) Animation support added to storyboarding.
(*) Beatmap Submission System support for graveyard maps.
(*) Fixed custom per-beatmap universal samples not being loaded as expected.
(*) Reorganised mod selection to make more sense (i hope).
(*) Fixed mousewheel volume changingW increasing more than decreasing.
(*) Fixed pausing during recovering causing an error to occur (return to song selection).
(*) Fixed bug where custom sample/volume settings are lost on opening song selection (unless you go to the Audio tab before clicking ok - please do this is you are using public build ;x).
(+) Web: Beatmap graveyard activated!  Thanks to Echo.

2008-03-10 (b222)
(+) Added a toggle to turn internal frame sync back on on the options screen.  Anyone experience newly-found lag - could you please try turning this on and report results?
(*) Fixed bug in editor where distance snapping multiple notes would cause them to flyyyyyy.
(*) Slider click input handled more gracefully, sorry about that one.
(*) Fixed bug where old maps loaded using the wrong default sampleset.
(*) Restored old metronome sounds/timing.

2008-03-09 (b221)
(+) Active mods are shown briefly in top-right corner during play mode.
(+) Ranked status is ressembled by a heart in the top-left corner of song selection.
(*) Editor loads in select mode by default for already mapped maps.
(*) Universal offset in options screen uses a fixed mp3 file.  Hopefully allow for more accurate settings.  Keep in mind you may find your offset WAS up to 20ms off using this method.
(*) Taking a screenshot pauses gameplay until saving is complete.
(*) Screenshots can be snapped when chat is visible.
(*) Song setup screen will only allow changing sampleset/volume settings if there are no timing-section independent settings already in place.  There is now an option to reset timing-section settings too.
(*) Options screen uses new font renderer.  Tidied up a lot.  More to come here.
(*) Mod selection screen uses new dialog container.

2008-03-08
(+) Stars on relax mode.
(*) Section pass/fail and countdown samples not based on beatmap volume settings anymore.
(*) Fixed update bar still showing up on non-menu screens.
(*) Fixed caret in IRC textbar not being at the end of the text.
(*) Fixed user stats not being removed when users log off.
(*) Fixed crash hitting 'esc' with chat up (for real this time).
(*) Increased relax mod recoveries to 5.
(*) Mousewheel is handled correctly with chat open.

2008-03-07
(+) Added relax mod.  No clicking involved,  spinners have less decelleration, song will slow down upon massive failure.  Totally unranked, just for fun mode dedicated to LuigiHann ;p.
(+) Relax and EasyMode give two hp recoveries - 90% recovery when failing.
(+) Mouse cursor and cursor trails are skinnable.  Ask me about this one (and also make me update the template skin...)
(+) Interface sounds skinnable (menuback, menuhit, menuclick).
(+) Selection tab skinnable.
(*) Skin template updated (LuigiHann check here for new stuff - esp. skin.ini and cursor).
(*) Sample loading code rewritten.
(*) Fixed bug where switching difficulties in editor failed (if case didn't match).
(*) Fixed bug where saving storyboard maps with sounds would cause a crash.
(*) Fixed ghost irc users displaying when they are not actually online.
(*) Fixed bug where osu! crashes when opening osz files associated with it.
(*) Fixed bug with slider input handling.
(*) Lead-in time works correct with doubletime mod.
(*) Rating of songs only appears after they are ranked.

2008-03-06
(*) Search searches difficulties.
(*) Updater might not crash anymore.  I think this could just be echo, though.
(*) After deleting a beatmap, the previous beatmap in the list is loaded.
(*) Update message always stays visible on main menu.
(*) Fixed crash on hitting escape while in play mode.
(*) Fixed replays slowing down during sliders and spinners.
(*) Ranking screen displays correct title when artist is missin gfrom beatmap metadata.
(*) Fixed error on deleting beatmaps.
(*) Fixed 'System.InvalidOperationException: Object is currently in use elsewhere.' (cecil can you confirm this one?)
(*) Fixed timing problems causing ranking screen mishaps, stuck sprites etc.

2008-03-04
(+) Editor menu can be accessed using keyboard shortcuts (Alt-f-a etc.).
(*) Changing slider tick rate in editor takes effect to all sliders correctly without a save+load.
(*) BPM used for countdown is halved for songs with BPM > 240.
(*) Screenshots handle transparency correctly.
(*) Local score data only saves replay for highest score for each song.  Saving every replay locally seems a bit stupid, and uses alot of disk space/cpu time when loading.
(*) Reduced random stuttering while playing.
(*) Fixed bug where chat fails to display online users after connecting to the server.
(*) Fixed bug where editor stops working after deselecting an item in the menu.
(*) Fixed(?) bug where cursor stops rotating.
(*) Search mode accepts ANY character input.
(*) Search mode no longer bugs out repeating the same letter many times.
(*) Updater only shows first thread percentage progress, not all.
(*) Merged online and local user display into a single class.
(*) Graphical enhancement of user display.

2008-03-03
(+) F12 takes a screenshot.
(*) Rewrote updater from scratch with new net library.
(*) Fixed scenario where song selection items get duplicated.
(*) Song selection uses new text renderer fully.
(*) Require only one 'enter' press when selecting difficulty of active song.
(*) Only ask about using 1/8 snap divisor the first time the editor is opened.
(*) Popup dialog closes correctly when leaving song selection.
(*) Tidied up score list layout.
(*) Changed update warning to bring up a once-off dialog.

2008-03-02
(*) Startup time reduced by a further 66%.  Overall, an 82% change in the time required to process each beatmap you have in your directory.  This also means the ranked status of songs can be stored locally, and built up in an index.  Which means we should see ranked/unranked filters and mass-updating pretty soon ;).
(*) Fixed selection not being deselected on mode changes.
(*) Removing/adding favourites is now creator-specific.
(*) Fixed minor graphics bug with username input on ranking screen.

2008-03-01
(*) Startup time reduced by ~50%.  More depending on how many beatmaps you have.
(*) Rewrite of song selection rotation handling.  Might be some bugs?

2008-02-29
(+) New in-game dialog interface.
(+) Main-menu tip added.
(*) Slider tick rate and multiplier are limited to sane values.
(*) Smarter countdown start timing.  Tell me if this screws up.
(*) Tooltips use new text renders.  Mmm smooth.
(*) A few minor graphical tweaks.
(+) Web: Mod ranking has last 7-day column (thanks to Echo).

2008-02-28
(+) Maximum score/combo achievable is viewable in test mode.
(+) Even while in distance snap mode, you can stack notes on other notes and sliders without toggling snapping off.
(*) Fixed bug where mouse speed gets reset on running the updater.
(*) Fixed bug in song selection (random crashes).
(*) Improved syncing of videos where offset is negative.
(*) Improved database performance of score retrieval and submission.
(*) Fixed unmapped songs from appearing incorrectly on song select.
(*) Circles only light up when they can actually be hit/missed (not when they can only be shook).  I'm pretty sure this is how ouendan works... and even if not - it feels better.
(*) Restored dimming settings/letterboxing to how they were before countdown.  Excluded countdown from dimming.
(*) Sprite rendering performance +30%.
(*) Gameplay rendering performance +50%.

2008-02-27
(+) Keyboard control in song selection drastically improved.
(*) Video performance +25%.
(*) Song selection performance +70%.
(*) Sprite rendering performance +15%.
(*) Fullscreen bug fixed (I think - can't replicate).
(*) Changed hit circle hit animation (a bit less smooth, more impact?).  What do you think?
(!) Quite a huge internal change for those performance increases - testers please check well for bugs :).

2008-02-26
(+) Mousewheel works to scroll backwards in history in chat.
(*) Fixed slider memory issues.
(*) Fixed spinner issues.
(*) 1/8 snap divisor causes a warning to display.
(*) Reorganised library code.  Quite a few dlls cut up and optimised.
(*) Optimisation for song select.  Reduction of around 30% cpu cycles.

2008-02-25
(*) New text renderer shouldn't lag anymore (tell me if it does you testers).
(*) Storyboard erroneous lines throw a soft-error and continue to load, rather than crashing osu!.
(*) Erroneous beatmap files which cannot be read at all are caught and a dialog will prompt on osu! start to delete such files.
(*) Timing setup window sample preview buttons update depending on the choice in the window.
(*) Timing points with sampleset changes which occur simultaneous to a hitcircle apply the sample change to that hitcircle itself.
(*) Fixed bug where 'nnnn' would end up in the search bar when answering popup dialogs when exiting the editor.
(*) Total restructure of input and main game loop code.  Wow, that was scary.
(*) Japanese unicode font sprite dropped from dll.  All song titles are now rendered using the new font renderer, with native fonts on your system.  This means that song titles should potentially be fully unicode supportive.  Of course, there are some forum/web scripts that don't support such characters yet which will need modification too.
(*) Progress metre display beatmap play time, rather than audio time.
(*) Found source of stuttering lag in game.  Will fix tomorrow - quite a large change required (GODDAMN ITS XNA'S FAULT YET AGAIN).

2008-02-24 (testing)
(+) New text renderer used in song selection (for song listing only).  Feedback please!
(*) Fixed loops not saving correctly.
(*) Fixed bug where "No scores have been set" displays incorrectly in some cases.
(*) Performance tweaks - startup time should be ~1-2s faster, and overall performance on lower-end machines should be improved.  Still working on the stuttering some people are experiencing.
(*) Adding to favourites displays a more appropriate message.
(*) Storyboarding works with '_' instead of ' ' characters.
(*) Storybaording works with '/' instead of '\' characters.

2008-02-24 (b210)
(+) Added audio samples for countdown (thanks to GuardianHX)
(*) Fixed slider sounds not working for skins.
(*) Improved efficiency of sample loading.

2008-02-23
(+) Added countdown sprites (thanks to LuigiHann).  Can be disabled on a per-beatmap basis.
(+) Progress in titlebar during play.
(*) Changed titlebar text slightly (more concise).
(*) Changed the way section pass/fail displays - if possible it displays the O/X.
(*) Fixed fire not displaying (oops).
(*) Fixed long-running problems with click depth order (ie. being able to click the URL on the title screen behind the chat buttons).
(*) Better handling of beatmaps which error out during processing.
(*) Interface hovering animations are handled a lot better.

2008-02-22
(+) Added parameters event with flip horizontal/vertical support.  _P,0,<startTime>,<endTime>,<parameterCode1>,<parameterCode2>,<parameterCodeN> where the codes are currently H for horizontal flip, V for vertical flip.
(*) Fixed sprite draw order being incorrect after a paste.
(*) Fixed whistle/finish icons not lighting up in some cases.
(*) Fixed bookmark deletion to delete the closest bookmark to the current position, rather than the first one found.
(*) Changed storyboard/section ranking pass/fail to match the HP bar icon correctly.
(*) Storyboarded samples will play correctly in the editor (not only the first time).
(*) Song setup screen volume adjustment adjusts all timing section's volume if they haven't been modified directly.
(*) Fixed bug where a 'Geki'/'Katsu' combo end is possible even with misses previously.
(*) Moved 'OK' buttons on dialogs to the left.  What was I thinking?!
(*) Fixed flashing of background image at start of song.
(*) Fixed bug with slider sounds and timing section sample-set changes.
(*) Huge code tidy up part 2!

2008-02-21
(*) Fixed blurry text rendering at 800x600 using new render engine.
(*) Fixed crashing during spectator mode in some situations.

2008-02-20
(+) New text rendering engine.  Allows for crisp small text an real-time AA'd text to be rendered from native fonts, rather than sprites.  Should improve the game's overall clarity after it is used in more places!  At the moment you can see it on the tip of the day.
(+) 'O' key at main menu opens options screen.
(*) Tips of the day fit on screen.
(*) Announcements and errors use new text display code.
(*) Fixed bug with sprites not playing the full unhover animation when hover is lost.
(*) Fixed bug with multiple events under a single loop being saved on one line.
(*) Play mode shows title of song in window title.
(*) Huge code tidy up.

2008-02-19
(+) Sample volume can be set per timing section.
(+) 'T' key taps in timing mode. 'R' key resets current timing section's timings.
(+) Added new tips of the day (thanks sinistro).  YES I KNOW THESE ARE NOT ALIGNED!
(*) Timing Setup dialog redesign.
(*) Loop events are saved correctly by the editor.
(*) Combo colour selection is more sane.
(*) Fixed bug where avatar and stats were not updated on logging out/changing active user.
(*) Changed appearance of error/announce/notice text popups.  Can be dismissed by clicking.
(*) Gave tooltip more padding away from mouse cursor so it doesn't get overlapped and hidden.
(*) More optimisations to sprite handling code.

2008-02-18
(+) Sample volume can be adjusted on a per-beatmap level.
(+) Tip of the day added into editor!
(*) Reorganisation of the song setup panel.
(*) 'V' key in editor skips to end of audio if already passed the last hitcircle.
(*) Code cleanup and slight optimisations.
(*) Fixed bug where custom colours were not being saved properly.
(*) Enabled visual styles for windows forms.  Meant to do this a while ago.

2008-02-17
(+) Number of custom combo colours in rotation can be chosen (2-5).
(+) Storyboarding looping groups allows a collection of tweens to be looped for n-times with only a single script entry.
(*)Save->load is no longer required for custom colours to be updated in editor.
(*) Database optimisations - loading scores in-game should be around 20000x faster.
(+) Web: Player ranking shows rank change in last 24hours (thanks to Echo!).
(*) Web: Increased performance of flash header on web page.  Was causing lag for some users.
(*) Web: Minor webpage modifications - cleaned things up.  Added a donate button on every page (a long-running suggestion).

2008-02-16
(*) Storyboarding layer fixes.
(*) Storyboarding allows subfolders.
(*) EliteBeatOsu! v3 by LuigiHann.
(*) Pipe character spam in chat fixed.

2008-02-15 (b196)
(*) Sound samples are layer dependant.
(*) Fixed bug with saving breaks.
(*) HardRock +6%, DoubleTime +12%.
(*) Initial HP climb is fast enough in DoubleTime now.
(*) Fixed overlapping slider ticks from appearing in play mode.  They still appear in edit mode to help with the editing process.
(*) Spinner spinning requirements halved in doubletime.
(*) Fixed frequency being set incorrectly for custom sound effects that don't run at 44100hz.

2008-02-14
(+) Both types of in-game stars are now skinnable (star.png is the one used for difficulty, star2.png is used for star-bursts).
(+) Added sound sample event type to storyboarding.
(+) Added layering support for storyboarding.
(+) Layer swapping support during gameplay.  At the moment a slight 'flash' can be witnessed during a layer swap (ie. failing -> passing, passing -> failing).
(+) Editor respects storyboard scripts, and saves them correctly after load.
(*) Fixed errors with localisation and storyboarding.
(*) Name displayed while watching replays doesn't have '-osu'.
(*) Posting a song with no artist specified doesn't add the '- ' prefix in the forum post's subject.

2008-02-13
(+) Colour transformations/tweens added for storyboard scripting.
(+) Layer depth handling improved for storyboard sprites.
(+) Easing support for tween lines.
(+) Origin support for storyboard sprites.
(+) IRC sendline cursor location can be seen, as well as selected text.
(*) Fixed clicking "update to latest version" opening webpage at main menu.
(*) Editor help is only displayed on compose screen.

2008-02-12
(*) Unnecessary file deletion skips wav files in the beatmap directory.
(*) Buttons are once again clickable.
(*) Fixed side-effect bug with spectator mode.
(*) Fixed bug with favourites not being deleted.
(*) Improved popup menu.
(*) Fixed mousewheel volume changes being bugged.
(*) Bookmarks can be skipped through by holding ctrl-left/right, rather than having to continually press.
(*) Mod selection tidied up, rearranged.

2008-02-11
(+) Right-click popup code for song selection screen.  Not fully smooth yet.
(*) Improvements to new button rendering (options menu in song selection).
(*) Fixes to click handling code which may improve overall performance.
(*) Fixes for instability when multitasking with osu! open.
(*) Fix for IRC erroring out when a connection cannot be established and 'F8' is pressed one or more times.
(*) Deleting a beatmap displays the correct name on the notification message.
(*) Half stars render correctly (rather than looking like 2/3 stars).
(*) Internal restructuring of code.

2008-02-10
(*) Scoring code changes.
(!) Finished building my new PC :D

2008-02-08
(*) Hard rock icon fades out correctly.
(*) Double Time speed reduced.
(*) New mods show up on the ranking screen.
(*) Adding a map to favourites adds all difficulties.
(*) Adding timing points shortcut (Ctrl-P) works in all editor modes.

2008-02-07
(+) New game mods: HardRock, SuddenDeath and DoubleTime.  SuddenDeath is fixed at no multiplier change, HardRock/DoubleTime are yet to be decided.  Feedback welcome.
(+) Mouse wheel changes volume during play mode.
(+) Middle mouse button opens menu during play mode.
(+) Ctrl-Up/Down snaps audio speed to presets in editor.
(+) Added song selection options to clear the unplayed list and delete beatmaps from disk.
(+) Two new sort modes - FavouritesA and FavouritesB.  I'll let you figure out those ;).
(*) Fixed hidden mod affecting edit mode (for real).
(*) Spacebar in play mode skips (even when not watching a replay).
(*) Local replays actually display the date properly (it was being stored correctly since last internal build, but not displayed in-game).
(*) Unplayed beatmaps register as played even when they are not ranked.
(*) Removed grey outline from all stars except those used to display difficulty.  Looks cleaner this way.

2008-02-06
(+) Simple fade, scale, rotation tweens implemented for storyboarding (no editor support).

2008-02-05
(+) Simple movement tweens being read from beatmap file for sprites.
(+) Added automatic bpm/offset detection in editor.  Not too reliable (as expected) so not sure whether this will make it to public. (Testers can try this using the shortcut alt-t)
(*) Fixed tapping setting offset on the second tap rather than the first.
(*) Fixed notes hit early bugging out with their fade-in/fade-out animation.

2008-02-04
(*) Fixed bug where usernames containing single-quote characters (') could not upload beatmaps.
(!) Modded some beatmaps.  Felt good to take a short break after a late night getting that internal build out :).
(+) Web: Beatmap listing sortable by user ranking. (Echo)

2008-02-03 b188
(+) Added two new skins (EliteBeatOsu! by LuigiHann and Shiruva by devkit4384).
(+) Currently spectating players are listed in play mode.
(*) Fixed texture disposal bug.
(*) BSS dialog changes to make things more straight-forward.
(*) BSS will remove old versions on re-upload.  This can be done whether doing a standard or full submission!
(*) Distance snapping disabled for the first note following a spinner.
(*) Changes to chat button graphics as to make them less confusing.
(!) Reverted to XNA1.1.

2008-02-02
(*) Testing a level after the last hitcircle will test form the beginning
(*) Background colour changes are saved by the editor.
(*) Restored old tap formula (oops).
(*) Changed 'ki' transition.  Looks a lot more natural.
(*) Fixed dodgy window focus problems with osu!.
(!) Migrated to XNAv2, Bass2.4beta.  Changed some routines and gained quite a bit of performance, especially on the audio front.  Unfortunately sliders are pretty screwed up... not sure if the new XNA is usable.
(+) Web: Player ranking is sortable and fully searchable. (Echo)
(+) Web: Player ranking includes totals of SS, S and A ranks. (Echo)
(+) Web: New frontpage statistics added.  Check them out.
(+) Web: Live feed of chat to front page.

2008-02-01
(+) Background colour changes can be scripted.  Its a start.
(*) Fixed usernames with spaces not working correctly in in-game chat.
(*) Fixed 'ki' sitting on top of the pause screen.
(*) New netcode for all incoming requests (roo's first contribution - hooray!).
(*) Fixed section ranks randomly appearing at end of song.
(+) Web: Added non-english language forum.

2008-01-31
(!) Note to testers that I'm not rebuilding the dll tonight, which means sprite/sample changes will not be present.
(+) Custom combo colouring can be setup in the song setup dialog.
(*) Section pass/fail sprites are cached.
(*) Section pass/fail sample volume increased.
(*) Slider ball drops correctly with the new fail animation.
(*) Fixed replay not working for non-ranked songs instantly after playing them.
(*) Date/time is now stored for local replays.
(*) Custom combo colours are retained when saving in the editor.
(*) Upload dialog starts in centre of osu! window, rather than some random location.
(*) Reverting changes doesn't prompt if no changes have been made.
(*) osu! logo on main menu re-rendered (glow at the bottom isn't clipped anymore).

2008-01-30
(+) Added samples for section pass/fail.  Created a timeline system to handle samples which aren't to be played instantly.
(*) Fixed bug where hp bar doesn't do its initial fill during lead-in time.
(*) Sliders don't "explode" in edit mode (because notes didn't before and it was inconsistant).
(*) Slightly changed fail animation.  How does it look? >.>
(*) Fixed score and ki fighting for draw depth.

2008-01-29
(+) Section pass/fail graphics implemented.
(*) 'V' in editor moves to near the end of the song if no hitcircles are placed.
(*) The initial hp-filling acts in a similar way to ouendan (ammended several times).  This means that if there is a very long initial lead-in (generally over 10 seconds), it will cycle through the '!!', '!' then 'ki' graphics, else it will remain the 'ki' the whole way.
(*) Fixed crash caused by attempting to connect to IRC at certain points.

2008-01-28
(+) Result sections implemented (automatic time-based).  No graphics/ranking screen yet - this will come soon.
(+) 'V' in the editor takes you to the last hitcircle in the beatmap.
(*) Hitting escape during spinner placement removes the spinner from the beatmap (similar to how slider placement works).
(*) Fixed uploading bug reported yesterday.
(*) Click the in-game update prompt button doesn't activate controls behind it.
(*) "Save As" changed to "Save new Difficulty" in the editor.
(*) When saving a new difficulty, the title/author are disabled and the version is focused by default.
(+) Web: Mod Rankings page completed.

2008-01-25
(+) Added test mode and song setup items to editor menu.
(*) Fixed crippling editor bug which cropped notes in osu files when saving.
(*) Fixed bug where mouse clicks could interfere with replays.
(*) "My Maps" sort mode defaults back to "Artist" when going to the play mode song selection.
(*) Exiting edit mode returns to the edit mode song selection menu.

2008-01-24
(+) Added "My Maps" filter mode for edit song selection.  Only shows maps created by the currently logged user.
(*) Hitcircles that occur after the mp3 has finished are trimmed on saving.
(*) F5 can be used to test the level in editor mode.
(*) Test mode only prompts for saving confirmation when the beatmap has changes pending.
(*) Soft samples are correctly read from skin folders.
(*) Web: Unranked maps are now displayed in profiles.
(*) Web: Work on site makeover.

2008-01-23
(*) Random 100% cpu freezes *should* be fixed now.
(*) Fixed BSS upload system screwing up BB code when editing posts in-game.
(*) Removed an unnecessary comma in osu file format.
(*) "User has left chat" only displays for those users that are in the chat channel.

2008-01-22
(*) I'm back *waves for the audience* :)
(*) ranking-F error no longer crashes game to windows.  Handled with an in-game message for now.
(*) Unplayed songs listing works once again.

2007-12-16
(*) Warning arrows for start of song.
(*) HP bar starts filling closer to first hitcircle for songs with long intros.
(*) Fixed bug where break time would sometimes result in no arrows being displayed.

2007-12-15
(+) Circles are dimmed except for the next to-be-hit circle.
(+) Added warning message when updating a beatmap to latest version where the creator is the local user.
(+) Mods are shown during replay playback.
(*) Changed 'ki' hp bard icon to cycle through the '!!' and '!' states on initial increase.  I changed this before to remain on 'ki' due to forum feedback, but on observing an ouendan video today noticed my initial assumptions were correct!
(*) Video with negative offset will play during lead-in time.
(*) Fixed bug with timing window selecting more than one timing point when opened.

2007-12-13
(*) Better handling of changing active user.
(*) Web: Rewrote all php code to fallback to mysql native (was using mysqli until the extension went missing).
(*) Web: Some prototyping of new website layout.

2007-12-12
(+) Added universal announcement system to game.
(+) Bottom-right text on main menu is clickable (loads osu! website).
(*) Changed connection behaviour of IRC.
(*) Favourite storage works internally - Just need some buttons now.
(*) Web: Moved a whole heap of the website code from mysqli to mysql due to a hosting fault.  Hopefully we'll have mysqli back soon :(.

2007-12-11
(+) Date based sorting.
(+) Bookmark sorting (not fully implemented).
(+) Internal button class for handling popup menus.
(+) Added message for spectator mode when target player is not playing.
(*) Fixed offset/chat settings not loading correctly on startup.
(*) Fixed play time values in online submission post (again).
(*) Increased size of editor open dialog to fit longer filenames.
(*) Fixed file associations failing to actually open osu!.

2007-12-10
(+) pUpdater caches file hashes and can automatically start osu! after updates.
(*) Compose mode cannot be entered until at least one timing section is setup.
(*) Fixed crash when attempting to open the Timing Setup panel with no timing sections created.
(*) Fixed dodgy music volume levels when swapping game modes.
(*) Fixed play time reporting wrong on web submissions.
(*) Fixed bug where distance snapping wasn't working at all in selection mode with sliders.
(*) Fixed bug with spinner sounds breaking up when consecutive spinners follow each other.
(*) Fixed bug where first metronome tick of a timing section would not play.
(*) Distance snapping tab turns red when it temporarily disables due to impossible placement.
(*) First point (point 0) of a slider has distance snapping applied during point editing.
(*) Universal audio offset is only calculated ONCE.  This quickens startup time on future executions.
(*) Universal Offset setting in options can go negative.  A metronome beat is provided to time against the current playing song.
(*) Exit on startup if moving a new beatmap (file association) failed.

2007-12-08 (b169)
(*) Support for semi-transparent avatars.
(*) Can't click on stuff behind chat in fullscreen chat mode.
(*) Fixed bug if port for IPC cannot be allocated (crash at song selection).
(*) Fixed online users overflowing off the screen.
(*) Tooltips for high scores list gives more details.
(*) People playing beatmaps you don't have will highlight in red rather than green.  You can't spectate these.
(*) Changed the "now watching" messages to reduce chat spam.
(*) Dragging a song to the osu! window.
(*) Fixed BPM changes causing huge lag in long LONG long songs (only if there are multiple timing sections).
(*) Added a delay to skin selection actually changing the skin.
(+) New themes added (Holiday, NES and WindWaker).

2007-12-06
(*) Changed post template to show full play-time, rather than drain length.
(*) Fixed another bug with slider placement (moving points with distance snap on in selection mode).

2007-12-05
(+) BPM is displayed on song selection.
(+) More tooltips added.
(*) Tooltips have a border and generally handle better.
(*) %20s are actually added to download url box.
(*) Test mode will respect lead-in if tested from close to the beginning of the song.
(*) Mousewheel/arrow key seeking can seek to the very start of the song.
(*) Fixed score submission/chat for usernames with strange characters, like a single-quote (').
(*) Fixed audio speeding up on fail with songs sampled at sub-44100hz.
(*) Web: Beatmap listing sorted by approved date rather than last update (for ranked listing only).

2007-12-04
(+) Menu playback controllable by arrow keys.
(+) Song selection controllable by arrow keys.
(*) Changed the way song selection is handled internally.  Fixed bug where background colours of songs change unexpectedly,
(*) Confirmation dialog when reverting to last saved (Ctrl+L or File > Revert to Saved).

2007-12-02 (b166)
(+) Can drag-and-drop new beatmaps and new mp3 files.
(+) First implementation of tooltips.
(*) Offline rankings display "no scores yet" rather than "update this beatmap".
(*) Distance spacing interval defaults to 0.8.  Is now saved and loaded from configuration file.
(*) Can now select and delete multiple timing sections at once using the timing setup panel.
(*) Fixed slider placement problems while distance snapping is enabled.
(*) Fixed bug with timing points window (time displays in the list were wrong).
(*) Fixed not being able to click away from rating properly (only on the buttons worked).
(*) Timing setup window selects current timing section by default.

2007-12-01
(*) Avatars are only loaded when full chat mode is visible.  This seemed to be causing lag for some during gameplay.
(*) Error message made more friendly for graphics cards which don't support required shader model.

2007-11-29
(*) Fixed skips not being sent in spectator in some scenarios.
(*) Fixed local replays not saving.

2007-11-28 (b164)
(*) Removed tilde key as a shortcut for opening chat window due to breaking some keyboard layouts.
(*) Fixed bug where local replays were not being retained.
(*) Fixed bug where spectator mode would stop working until restart of osu!
(*) Fixed send rate of replays.

2007-11-27
(*) Fixed crash on hitting up arrow in chat with no message history.
(*) Hitting 'escape' after already failing brings up retry screen rather than returning to song selection.
(*) Icons on submissions are retained even after updates are made to the post.
(*) Fixed bug where pasting notes over the top of other notes would leave some overlapping notes behind.
(*) Fixed health bar sometimes not fully sliding into gameplay after a break.
(*) Fixed mouse cursor going crazy during break time in spectator mode.
(*) Better spectator sync accuracy?
(*) Web: Cleaned up database a bit.

2007-11-26 (b162)
(*) Major improvements on spectator score/play accuracy.
(*) Toggle buttons on chat dialog now don't change text.  This was confusing apparently!
(*) Fixed scoring bug where combo went higher than it should.
(*) Fixed offline replays not playing back.
(*) /quit in chat mode also closes chat panel.
(*) System generated chat messages are not added to message history.
(*) Changing usename while chat is open disconnects from chat.
(*) Spaces are replaced with %20s in the download text field in upload dialog.
(*) Changing the sampleset can be done without an initial save of old files.
(*) Default smapleset option in song setup screen affects all timing points if they all have same (default) settings.
(*) Creator field is locked to logged-in username.
(*) Spinner approach circle hidden in hidden mode.
(*) Increased network connection pool and added stronger error handling.
(*) IRC usernames are enforced to be valid.
(*) Playing offline does not cause errors to appear.
(*) Auto-hiding of chat works better with pause mode.
(*) Play button on main menu unpauses when music is already paused.

2007-11-25 (b160)
(+) New timing control screen.
(+) Samplesets can be defined per timing section.
(+) In-game song rating system.
(+) Time signature support added.
(+) Auto chat login.
(+) Auto chat hiding during gameplay.
(*) eyupstars v1.1 (currently in osu! only - no web support).
(*) BSS submissions have a link to the beatmap listing page.
(*) HP drain only starts after the first note after a break.
(*) Combo and HP bar slide out during breaks.
(*) Better handling of mid-song spectating.
(*) Song selection notification icons fade/slide in!
(*) Fixed hp icon not pulsing on initial increase.
(*) Fixed graph sometimes not drawing correctly.
(*) Web: Fixed some broken leader records.

2007-11-24
(+) Added buttons for controlling replay playback.
(+) Added buttons for hiding/refreshing full chat mode.
(+) Skip commands are sent to watchers in spectator mode.
(*) Hitting 'Escape' or 'Ctrl-Z' while placing a slider in edit mode will remove it altogether.
(*) Menu play controls appear in front of chat overlay.
(*) Spectator mode is disabled on entering play or edit mode.
(*) Clicking yourself in the spectator list disables spectator mode.
(*) Skip button can be clicked in replay mode.
(*) Huge hacks to the input system to allow mouse input during replays.  Hopefully this won't own anything.
(*) User buttons flash red when updating stats.
(*) Added new icons/buttons for online ranking notifications (when a song needs updating etc.)
(*) Hitting escape while online chat is visible will close it first, then exit the game on the second keypress.
(*) Fixed bug where game would hard crash if you cancelled the login prompt when uploading a song.

2007-11-23
(*) Entering edit mode resets all mods.
(*) Fixed bug with avatar dimensions being reversed.
(*) Main menu plays from start of song on songs after the first.
(*) Changed chat font once again.
(*) Small memory optimisations.
(*) Fixed slider tick PC reboot bug.

2007-11-22
(+) Audio controls on main menu.
(+) Centralised all internet request instances to one managed location.  Should make comms more reliable.
(+) Chat has send history (up/down arrows to access).
(+) New font for chat console.  Should be easier to read at all resolutions.
(*) Fixed BSS bug where forum threads were not being linked correctly.  YAY!
(*) Improved layout of chat engine.  Full mode uses windows mouse cursor.
(*) Fixed sliders with repeat arrows not working correctly with 'Reverse Selection'.
(*) Improved account setup dialog.  Force it to open on startup if no login is provided.
(*) Reorganised quite a lot of code.  I wish I had more time to do this x.x.
(*) Removed "All" from sorted selection lists - there is an All option now so its not really required.
(*) Changed star texture, removing unneeded pixels and optimising for performance.
(*) Added debug for BSS dialog to try and fix this error.

2007-11-21
(+) Added avatars and basic statistics to chat userlist.
(*) Fixed video disappearing in editor when letting it play through fully once.
(*) Changed input handling code so mouse input can be grabbed from the local user during replay/spectator mode.

2007-11-20
(+) Started implementation of Full-mode chat (expands to full screen).
(+) Clickable user buttons to spectate that user.
(*) Fixed seeking failing for high BPMs while playing.
(*) Spectator mode all-round bug-fixes.
(*) Ctrl+O in editor triggers the open dialog.
(*) Fixed some sliders losing a few pixels on the bottom-right edge.

2007-11-19
(+) Can start watching someone midway through a song.
(+) Added in-game support for hidden S/SS ranks.
(+) Skins can skin menu sounds (menuhit.wav, menuback.wav, menuclick.wav).
(*) Huge improvements/fixes to spectator mode.
(*) Test mode doesn't swap game to fullscreen anymore.
(*) Fixed bug where osu files inside osz would not get updated in some rare circumstances.
(*) Fixed file associations not registering correctly in vista.
(*) Removed some skinning from the song selection screen (the top and bottom black bars and search background).  I think this feels better.
(+) Web: Added hidden (stealth) S/SS ranks.

2007-11-18
(+) Texture caching code for storyboarding.
(+) Network code to allow realtime broadcast of replay data via in-game chat.
(+) Ghost S/SS rankings (for hidden mode achievements).  Not yet implemented on web.
(*) Fixed stats showing "An Error Occured" when user has not played any songs.
(*) Association mapping is smarter (doesn't create when already existing).

2007-11-17
(+) Double-clicking an osz file opens it in song selection as the active item.  This also works when osu! is already running.
(*) 'Beatmap is extracting' dialog now working as expected.
(*) Fixed editor entering unknown modes.
(*) Changed file association error messages to be more informative.
(*) Fixed bug where setting custom sample mode for beatmaps had no effect.
(*) Changed background blackness level to match old colours.

2007-11-15
(+) osu! associates itself with .osz files, and can load them by double-clicking a beatmap file directly!
(+) New dialog to show osu! is extracting beatmaps, rather than just a black screen.
(+) Added an option to enable/disable custom sound sets (song-specific) in song setup.
(*) Really fixed hidden mode not working in replays (approach circles don't show anymore).

2007-11-14
(+) Date/time of score are shown on the ranking screen.
(+) In-game beatmap updating is a lot smarter (updates pending beatmaps, and is more informative).
(+) Mods are displayed in Now Playing chat messages.
(*) Fixed non-ranked songs being able to be ranked.
(*) Fixed hidden mode not working in replays.
(*) Fixed chat crashing on some long message strings.
(*) Clicking sound no longer occurs when osu! doesn't have focus.
(*) Web: Logged in player position is highlighted on individual song lists.

2007-11-13 (b144)
(+) Skins can skin soft/loud soundsets separately (ask me for now, will update post later).
(+) Can move threads from WIP to completed from the upload dialog.
(*) Fixed dodginess with upload system.
(*) Fixed 'played by guest' displaying on ranking.
(*) Fixed soft sampleset slider loop not looping properly.
(*) Fixed distance snapping not toggling properly in select mode.
(*) Fixed editor bug where sprites would appear incorrectly after moving on timeline.
(*) Combo bursts occur every 50 hits, rather than 100.
(*) Moved replay marquee text slightly higher.  Added a note about skipping intros with 'space'.

2007-11-12
(+) New mods: Hidden (+6%) and NoVideo (no effect).
(+) Crosshair mouse pointer while placing notes in editor.
(+) Double-clicking on a note in the gamefield/timeline seeks to that point in time.
(+) Accuracy added to in-game results screen.
(*) Changes to layout of results screen.
(*) Made selection of notes in the gamefield more sensible (closest time-wise gets selected first).
(*) Fixed combo numbers being incorrect after a paste/duplicate.
(*) Game prompts for login if F8 is pressed before logged in.
(*) GPU load reduced by almost half in play/edit modes.
(*) Web: Accuracy stat is now a rolling average.  It will be a lot more dynamic, and mean you can make larger improvements/dents in it :).  Temporarily adjusted to have a huge effect for plays over the next week or so.

2007-11-11
(+) Totally reworked how alt-snapping/grid snapping is handled.
(+) Bookmark reset button.
(*) Sharpened and recreated all editor side-tab sprites.
(*) Fixed avatars where width is greater than height.
(*) Fixed editor resolution change not resizing the black overlay area.
(*) Fixed "load thread after submit" not doing anything.
(*) Select All forces 'selection' tool.
(+) Web: Ranking support added to new submission system!  Should make the mod's job easier :).

2007-11-10 (b140)
(+) 'Now Playing' support added to chat.
(+) New layout for mod selection, and "random song" button added.
(*) Updates to submission dialogs and backend code.
(*) Note stacking made less sensitive - was stacking notes which were quite spread-out in time.
(*) Avatars have a frame.
(*) Editor optimisations.
(*) Fixed backgrounds not being updated if already existing in the beatmap's folder.
(*) Keyboard controls disable when paused with chat displaying.
(*) Skin template updated to include retry button as well as updated sizes for ranking screen buttons in general.
(+) Web: Individual song scoreboards have accuracy ranking.  Not sortable yet, but will be soon :).

2007-11-09
(+) Basic avatar support in-game.
(+) Editing posts is possible with submission system.
(*) Fixed sliders killing combo on missing the end hit.
(*) Roulette is more random than before.  Doesn't crash with non-beatmapped songs.
(*) Changed ingame IRC server to private peppy server. irc.ppy.sh #osu will be our new home.

2007-11-08
(+) Roulette mode added to song selection (Ctrl+R for testers).
(+) If a note is clicked way too early (more than 400ms currently) it will shake rather than count as a miss.
(*) Force topmost window when opening.
(*) Optimisation of hitobject drawing loop.
(*) Slider drawing code does much less overdraw.
(*) Memory footprint reduced significantly.
(*) Fixed flame not drawing during spinners.
(*) Fixed first flame/star-burst occurring on 31 combo rather than 30.

2007-11-07
(+) Current time counter added to test mode.
(+) Forum posts from in-game submission are linked to beatmap database.
(*) Huge optimisations in sprite management (CPU load).
(*) Small optimisations in GPU drawing calls.  Unfortunately it seems like I'm hitting a fill-rate limit with starbursts during gameplay.  Can people who get lag with this effect please report it?
(*) Scratch that.  Did some optimising on star-bursts and now maintain a constant 60fps on my nvidia card.  Lets see how this goes.
(*) Combo fire effect capped at a lower maximum height.  It looks better this way.

2007-11-06
(+) Beatmap submission integration in osu!.  Mostly complete, just needs some touch-ups!

2007-11-05
(+) Web: Beatmap submission scripts mostly complete to: Post, Edit, Secure file upload, Add new beatmap, Update existing beatmap.
(*) 'F5' at song selection forces a refresh even if no new osz files are found.
(*) Fixed bug where stop reset song position after seeking.
(*) Ingame search no longer searches difficulty names.

2007-11-04 (b130)
(+) Added 'SS' ranking (ALL300).
(+) Added basic test mode statistics.
(+) Slider tick rate of 3 allowable (3/8, 6/8, 12/8 kinds of timings).
(+) Spinner sounds are customisable.
(+) Sounds can be loaded from a skin directory.
(+) Added 'retry' button on ranking screen.
(+) Support for quit (/quit) in chat.
(*) Huge improvements to audio sample handling.
(*) Fixed chat nickname clashes.
(*) Much better handling of dropped/failed connections for chat.
(*) Videos scale based on width instead of height.
(*) Fixed slider sounds not stopping when the 'stop' button is pressed.
(*) Fixed bug where game will still start if the mp3 of a beatmap is missing.

2007-11-03 (b129 includes some)
(+) Userlist for chat.
(+) Support for actions (/me) in chat.
(+) Star bursts added to gameplay.
(+) Added "unmapped" folder to sorting lists.
(*) Minor changes to gameplay effects.
(*) Chat ticker fades faster in editor (gets annoying otherwise).
(*) Keyboard layouts fixed for chat.
(*) Fixed missing last note causing failure.
(*) Chat gracefully quits.
(*) Ping is replied to correctly.
(*) Fixed stats display for users with 0 ranked score.
(*) Fixed problem with online scores.
(*) Fixed bug where song selection would not work after exiting from edit mode using the 'x'.

2007-11-02
(!) I slept.

2007-11-01 (b128)
(+) Basic chat support.
(+) User stats on main menu.
(*) Shrunk osu! on song selection screen.
(*) Fixed crash when typing 'osu' into search in play mode with unmapped mp3s present.
(*) Mouse cursor is visible when error dialog pops up.
(*) No longer bothers to submit scores when the song isn't rankable.
(*) Fixed potential bug where audio ends less than the fadeout interval after the last note.
(*) Fixed accuracy displaying as huge numbers for different localities.

2007-10-31 (b127)
(+) New star rating system courtesey of eyup!  Check out the in-game star ratings.
(+) More new menu effects.
(+) Search shows match count.
(+) Displaying song length.
(+) Item counts for folders.
(+) Search auto-selects when refined to 1 song.
(*) Main menu chooses new random song after last ended.
(*) Song selection repeats selected song if it ends.
(*) Lead-in delay actually works!
(*) Fraeon's skins updated to v1.3.
(*) Changed default (when first running osu) snap divisor to 1.

2007-10-30
(+) New main menu effects and "Now Playing" display added.
(+) Added option for lead-in time for songs that start quickly.
(+) Added a brief note in song selection screen for new beatmappers.
(*) Start button replaced with pulsating osu!
(*) Search mode efficiency improved greatly.
(*) Search query reset when changing tabs.
(*) Pointer restrictions are much more precise.
(*) Can't pass song by freezing osu! during gameplay until after audio ends.
(*) Improved key-repeat delay function.  Should feel a lot better for seeking etc.

2007-10-29 (b125)
(+) Shift+1-8 changes divisor.
(+) Ctrl+Mousewheel changed to adjust divisor.
(*) Replaced search tab with 'All'.
(*) Default sort mode is now 'All'.
(*) Slider snap divisor set back to how it should be (not normal divisor/2).
(*) Fixed login entry dialog not disappearing correctly.
(*) Audio pauses when starting test mode.
(*) Test mode doesn't start if no circles are placed.
(*) Fixed stacking bugging when overall difficulty is increased.
(*) Mouse can leave window immediately after a song is passed, rather than waiting until ranking screen.
(*) First note after break time is automatically made a new combo in editor.
(*) Updated almost ALL skins.
(*) Fixed slider accuracy.

2007-10-28 (b123)
(+) Bookmarks display in timeline.
(+) Added user stats to song selection screen.
(+) Custom sample support on a per-beatmap basis.  (Ask me for further details)
(+) Added 'other' category to sorting, showing any which don't fit into alpha sorting folders.
(+) Added 16:9 letterboxing when in break time.
(*) Fixed ki-metre dropping off the screen in test mode.
(*) Cursor unlocks during replay.
(*) Can skip in replay by hitting 'Space'.
(*) Reversing selection handles new combo notes better.
(*) Fixed bug with difficulty sorting not showing some songs.
(*) Fixed circles turning black in edit mode.
(*) Fixed bug where timing sections would be screwed over in certain situations.
(+) Web: Beatmap listing is searchable.
(+) Web: Player Listing goes beyond the top 50.  Has an option to find yourself.
(*) Web: Fixed download button not handling 's correctly.

2007-10-27 (b121)
(+) Title/Difficulty sorting.
(+) Full dynamic song searching!
(+) Sorting tabs in place.
(+) Mouse is restricted to window during gameplay.
(+) 'Alt' distance-based snapping can be adjusted via Alt+MouseWheelUp/MouseWheelDown.
(+) Skins can specify how many frames to use in the slider ball loop.
(+) Difficulty stars increase in halves.
(+) 'Unplayed songs' folder added to sorting.
(*) Mousewheel seeks by default.  Holding 'Ctrl' changes placement controls.
(*) Caching miss sprites for play mode.
(*) Fixed bug where gameplay would not end if last hit object was too close to end of audio track.
(*) Skin template updated.

2007-10-26
(+) Artist sorting fully implemented!
(+) Skin preview added to options screen.
(+) Skinning support for more menus added.
(*) Skin template updated.  Added comments, readme and new sprites.
(*) Pacman skin updated.
(*) Fixed layout of login entry dialog.
(*) Fixed geki/katu bonus not appearing when missing the first hit of a slider.
(*) Fixed 'Ctrl' not working for spinners.
(*) Fixed new mp3s not displaying.

2007-10-25 (b114)
(*) Spinners regenerate more HP.
(*) Huge performance increase on song selection screen.
(*) Fixed duplicates in local high-score entries.
(*) Fixed scores not refreshing after song completion.

2007-10-24
(+) Playfield/menu background and menu buttons added to skinnable sprites.
(+) Skins can take control of slider track colouring.
(+) Slider ball sprite can be flipped on reversal.
(+) Added three new official skins.
(+) Pulsating 'osu!' on menu is now clickable.
(+) Alt-snapping works for moving existing beats too.
(*) 'Ctrl', 'Z', 'X' keys also act as clicking in gameplay mode.
(*) Can't fail in replay/test mode.
(*) Miss HP drain is now decided by "HP Drain" rather than "Overall Difficulty".
(*) Fixed bug with Editor's "File > Open" dialog crashing in some cases.

2007-10-23
(+) Can use space bar instead of left-click for gameplay.
(+) Added ability to disable metronome clicking (Timing > Metronome Clicks).
(*) Fixed offline scores not displaying when changing from online Page 2+.
(*) Halved slider drain on missing ticks/repeats.
(+) Web: Added pending list to beatmap listing view.
(+) Web: Framework for new beatmap submission process.  Looking good :D.

2007-10-22 (b110)
(+) New error handling dialog allows copy+paste.  Also forces a save in the editor to avoid confusion.
(+) Quitting via alt-f4 or the 'x' button is a lot less abrupt, and gracefully exits to the previous mode.
(*) Closing the window in editor mode now acts as it should (can be cancelled).
(*) Changed 1/8th timeline tick colour to yellow (easier to distinguish from red than orange was).
(!) Audio libraries updated.

2007-10-21
(+) Added play-testing mode in editor.
(+) Added ability to recalculate slider lengths (very useful after changing a song's BPM).
(+) iDork skin by Fraeon added to extras.
(+) Percentage progress added to editor.
(+) Full TabletPC support!
(*) Sliders have a minimum length when being placed/recalculated.
(*) Fixed replay data not saving correctly.
(*) Fixed bug where updating an .osu on a song with no rankings had weird results.
(+) Web: Moved all ranked beatmaps to a new folder to increase organisation.
(*) Web: Fixed equal scores taking wrong precedence order.

2007-10-20 (b107)
(*) Fixed editor crash when no sampleset is selected for a new beatmap.
(*) Fixed editor sluggishness/lag on some PCs (was related to loading skins).
(*) Changed dynamics of song selection screen.
(*) Improved performance/smoothness of song selection.

2007-10-19
(+) Added "dead" area to song selection screen when hovering to the left.
(*) Fixed bug where beatmap would be overwritten when checking for updates if it was not officially ranked.
(+) Web: Added play guide to FAQ (thanks to Esque).
(+) Web: Added screenshots/video section to the About page.
(+) Web: Can sort beatmap listing by minimum difficulty.  Difficulty icons also added.
(*) Web: Changed displayed date for beatmap listing to original submission date, rather than last approved date.
(*) Web: Changelog now has graphics - please read this changelog using the <a href="http://osu.ppy.sh/index.php?p=changelog">actual changelog page</a> (should I move this thread?  Or do you guys want to be able to reply to it?  Maybe each changelog entry should have a comment section.. although I'm not sure how often this would get used.)

2007-10-18 (b105)
(+) Can get updated osu files from in-game!!
(+) Can enter login by clicking the message on the main menu.  Hopefully a bit more obvious.
(+) Custom colours can be specified in beatmaps.  Overrides skins and defaults (again - ask me about this one if interested).
(+) Added Cartoon skin by KiraCatgirl to osume extras.
(*) Fixed page display showing 1/0.
(*) Fixed forcing update halfway through playing a song in some rare cases.
(*) Slider end-circles fade when slider is complete (how many times have i broken this? i've lost count).
(*) Locally recorded username defaults to the same as online one.
(*) More work on the new sorting framework.  I've got things organised quite nicely, but not displaying in the GUI yet.  There's quite a lot to think about with this stuff - way more than meets the eye.
(+) Web: Added ranked position to profile.

2007-10-17
(+) Support for per-song skinning (ask if you care).
(*) More work on the new song selection/sorting system.  Ahhh slow progress.
(*) Fixed bug where replay occasionally fails.
(*) Fixed bug where editor would crash on startup (new songs only).
(*) Removed audio md5 calculation.  Not being used at the moment, no real point.

2007-10-16 (b102)
(*) Fixed spinner sound playing while paused.
(*) Fixed video being dropped from osu file if video is disabled (or codec fails) while editing.
(*) Default curve type is now bezier.
(+) Web: First post is shown on song detail pages.
(*) Web: Download links work from song detail pages.

2007-10-15
(+) Distance based snapping (hold alt during placement).
(+) Slider preview added to timing window (to help with velocity/tick adjustments).
(*) Fixed bug where 'next page' button is displayed when it shouldn't be.
(*) Fixed bug where editor settings are not saved on alt-f4 forced exit.

2007-10-14 (b100)
(*) Slider tick sound obeys the audio volume settings.
(*) Quite a large scoring bug fixed.  Took a lot of time and effort to ensure no data was lost.. Thanks to eyup for the help.
(*) A bit of work on new sorting system for menus.

2007-10-13 (b99)
(+) Soft sound set added.
(+) Bookmarks are saved.
(+) Ctrl+B adds bookmarks, Alt+B removes.
(+) Added automatic offset detection back in.
(*) Fixed crash when trying to play a song with no notes placed.
(*) Slider ball is skinnable.
(*) Fixed ki sprites not loading for skins.
(+) Web: Date formats made a lot cleaner.
(+) Web: Ranking distribution.
(+) Web: Added sort arrows for beatmap listing.
(*) Web: Moved more stats to generate in a static fashion, therefore increasing the number of places they can be used (see player ranking).

2007-10-12
(+) Breaks can be removed by right-clicking on them.
(*) Fixed bug where notes could be dragged into break periods.
(*) Fixed bug where sort order isn't updated on drag end.
(*) Skin is used for slider start/endpoints.

2007-10-11
(+) New sounds for spinners and slider ticks.
(+) Basic wiring for selecting different sound-sets in the editor.
(*) Spinner sound effect loops a lot better.
(*) Fixed score to appear in front of scorebar.
(*) Fixed skin selection in options when more than one custom skin exists.
(*) Fixed new songs not being remembered properly when osu! is closed (argh).
(+) Web: Basic "Player ranking" page.
(+) Web: New profile statistics.
(*) Web: Time in lead will not be updated if you beat your own #1 score.
(*) Web: Started to store stats in the user table rather than calculate on-the-fly.  Need to do this for all stats eventually.

2007-10-10 (b96)
(+) pUpdater v2 - supports optional packages, and is much more robust.
(+) Can add points to existing sliders (Ctrl+Click in select mode).
(*) Fixed skin manager to handle cases when colours are not provided correctly better.
(*) Fixed spinners not being replaced by skinned versions.
(*) Fixed editor background being too bright after loading/reverting to saved.
(*) Fixed events not being ordered correctly in .osu file (caused warning arrows to not appear sometimes).
(*) Fixed skip not playing fair with beatmaps that have no timing points (PLEASE don't make maps with no timing... it makes me cry).
(*) Adding a new timing point adds it with default values - current time and same BPM as last.  You can adjust/reset as required!

2007-10-09
(+) Keyboard shortcuts for bookmarks (Ctrl+Left/Right arrows).
(+) Custom preview time can be set in editor (Timing>Set Current Position as Preview).
(*) Fixed bug where skip button sometimes doesn't work (if you click it too fast).
(*) Fixed bug where sliders sometimes reported misses when they shouldn't (sorry eyup).
(*) Fixed depth problems with multiple background event layers.  Now orders depth by how they appear in the osu file (back-to-front).
(*) Skinning takes effect on results screen and in editor
(*) Skin.ini contains skin/author metadata.
(+) Web: Sorting for the main beatmap list by headers.  Still needs some new columns added (need to work on DB a bit more).
(+) Web: Pagination for beatmap listing.

2007-10-08
(+) Skin selector in options.
(+) Bookmark support complete!
(*) Skin ini file made available.  Currently only supports changing the colouring of different hit-circle/slider combos.
(*) Replay during break time is smoother (when mouse was held during original play it stuttered).
(*) New songs are still remembered even if game is forced to quit (alt-f4).

2007-10-07 (b89)
(+) Vertical red indicator line added to compose timeline at timing points.
(+) Skinning support.
(+) Ctrl+Mousewheel seeks forwards and backwards.  Hold shift for 4x speed.
(+) Timeline ticks are colourised.
(+) New error popup for in-game warnings/errors.
(*) Fixed sliders being audible after fail (during spin-down time).
(*) Cut 6ms silence from hit-whistle sample.
(*) Slight change to the hitcircle fadeout animation (easing added - looks a lot closer to ouendan).
(*) Huge performance increase when sprites are being rendered off-screen (ie. song selection).
(+) Web: Ajax-ish user ratings added for beatmaps.
(+) Web: New stats and completion of beatmap import script.

2007-10-06
(+) Online ranking displays in-game.
(+) Replays can be downloaded and watched.
(*) Replays are compressed using 7z rather than zip.  Therefore, all high-scores until now will not have valid replay data (except local).
(*) Fixed high scores appearing on edit selection screen.
(*) Metadata entry uses account username by default.
(*) Fixed mouse trail disappearing after replay.

2007-10-05 (b87)
(*) It is possible to get S rankings again. Sorry!!
(*) Stop playing slider/spinner sounds on fail.
(*) Replay shouldn't fail anymore.
(*) Work on the database backend.

2007-10-04 (b86)
(+) Files which are not used in the current beatmap are removed before packaging.
(+) Added slider beach ball animation (thanks to Kylecito!).
(+) Unplayed songs are remembered between launches of the game.
(+) Added warning arrows after a break period.
(+) Added a skip button for songs with long lead-ins.
(+) Added 'D' ranking.
(*) Removed hit sprites which are no longer used (due to ammendments in scoring).
(*) Undo/redo history is cleared when opening a file or starting a new beatmap.
(*) Fixed some bugs with pause mode.
(*) Working on issues with filenames inside zip files.. tempted to just force them to only contain the ansi range.
(*) Fixed a few crashy bugs.
(*) Halved slider precision for all snap divisors.

2007-10-03
(+) Pause/fail menu.
(+) Newly imported osz files appear in green on the song selection for that game run.
(+) Added slider tick rate adjustment to editor.
(+) Added new timing option "Resnap current timing section".
(+) Background fades when outside of a break period - becomes fully visible during break-time.
(+) Backgrounds images and movies can be added in the editor!
(+) Added support for changing the background colour on the gamefield!
(+) Added "osu!!" and "go!" graphics for when a spinner is finished successfully.
(*) Slider adjustments are completed when doing a "resnap all notes".
(*) Force updating slider lengths after exiting timing screen (hopefully allow more leniance for people who change bpm/velocity after already having sliders placed).
(*) 'Ki' symbol is displayed as normal sprite for the song-start period. (in response to Asho "When the meter fills up at the beginning, the slider says "‹C"/"Yes" all the time.")
(*) Irregular slider repeat ticks maintain their location. (in response to Asho "When it comes to Phrases with irregular dots, a return arrow does not relocate them")
(*) Combo display fades out when 0. (in response to Asho "The combo counter is invisible if the combo is 0.")
(*) Changed same-colour combo end scoring. (in response to Asho "Kiai/Beat Bonuses are awarded at the end of a same-colored string as long as there weren't any 50s or Xs in it...")
(*) Getting 50% of ticks on a slider results in a 100 score (as opposed to the previous 75%).
(*) Scores can have a fail record.  They will not be recorded if this is set.

2007-10-02
(+) 'Break Time' insertion/deletion support in the editor.  Time period is automatically calculated - reinserting at the same point will run this calculation again.
(+) Basic background image insertion support in the editor.  Currently accessible by hitting 'i' in design mode.  This will probbaly be changed before a internal release!
(+) Timeline ticks adjust depending on the current snap divisor.
(+) Replay data is streamed via a zip deflator.
(+) New icons for replay/back buttons on ranking screen.
(*) Fixed bug where dragging on the snap divisor selection bar into the timeline would do crazy scrolling.
(*) Fixed song selection bug.
(*) Slider point changes are undoable.
(*) Added help text to replay screen.

2007-10-01
(+) Online ranking.
(+) Replay implemented.
(+) Mods show up on the ranking screen.
(*) Mods are internally handled better - should prove nice for when more are added in.
(*) Perfect now means you haven't broken a combo (including slider midpoints).

2007-09-30 (b79)
(+) 90 degree rotation in editor.
(+) Undo support in editor.  Still a bit buggy - be careful when using!
(*) Difficulty stars calculation includes the number of notes/second.
(*) Fixed high scores not recording correctly.
(*) Fixed selection area causing PS1.1 cards to crash.
(*) Fixed slider end circles breaking combos when too far away.
(*) Replay support fully complete.
(*) Fixed perfect appearing behind the line on the results graph.
(*) Fixed ranking screen exiting on hitting 'q'.
(*) Preloading hit-value sprites when entering play mode.
(*) Added graphics fix for cards which do not autodetect a suitable render-mode.
(*) Fixed sliders stacking incorrectly (i hope - eyup can you check this?).
(*) Fixed background images being offset too far vertically.

2007-09-29 (b78)
(!) Fixed sliders not displaying for some people.  Woot.
(*) More work on replays.
(*) Extended timer height so selection can be made easily.
(*) Fixed pause/play occurring even when ctrl is held down.
(*) Added code to detect pixel shader version (reintroduced smooth curves for PS2.0+).

2007-09-28 (b77)
(+) Added confirmation dialog for snapping all notes/removing all timing sections.
(+) Editor now remembers preferences for curveType, gridSize, snapDivisor.
(+) Osz packaging provides a default filename based on the artist/title.  Hopefully stop people from using []s in the filename (phpbb no likes).
(+) Mouse speed adjustment in options.
(+) Added shortcut keys for specific grid size modes (Ctrl+1-4).
(+) Added slider to adjust beat snap divisor.
(+) Basic static image background support.
(+) Manual entry button added to timing dialog.
(*) Fixed stacking of notes at the end of slider causing the slider to move out of place.
(*) Fix for one remaining localisation bug.
(*) Fixed timeline selection being slightly weighted to the right-hand side with overlapping notes.
(*) Fixed crash when nudging notes while none are selected.
(*) Fixed spinner first 100-point score coming half a sping too early.
(*) Mod buttons stay lit up after finishing playing a song.

2007-09-27 (b76)
(*) Increased slider/spinner timeline resize handle by 4 pixels.  Should be easier to grab.
(*) Cannot play zero-length spinners and sliders in editor anymore. (caused null reference crashes and other horrible stuff)
(*) Fixed bug where music and effect volume levels would drop if universal volume is less than full each time the options screen is entered.
(*) Fixed bug where sliders would count as two misses when missed.
(*) Fixed bug where registering login details while running fullscreen resulting in abnormalities (windows forms grr).
(*) New songs should be selectable even in a long list (the ones that appear as blue).
(*) Audio offset was applied in the wrong direction!  Whoops.
(*) Fixed bug where setting an offset would break seeking in editor.
(*) Spinners give 100 points per rotation, 1100 for bonus rotations.  Also ramped down difficulty slightly (around 10%).
(*) Increased the rate at which up/down arrows affect tempo change.
(*) Added an end circle for spinners on the timeline.
(*) First of a number of changes to spinner motion - the mouse no longer needs to remain on the spinner itself, and will be moved back closer to it if too far away.
(*) Ensure sliders are updated instantly after a bpm alteration (as opposed to after a save/load).
(*) Fixed SliderTickRate to not affect the actual speed of a slide - only the number of ticks on it.  Setting this higher (2 or 4) will double/quadruple the number of ticks; setting to 0.5 will halve.
(*) Fixed break periods not showing in editor always.

2007-09-26 (b74)
(+) Basic support for break or intermission periods in songs.
(+) Added '!!' danger sprite when hitting very low HP.
(*) Handle left/right mouse clicks better (there were problems when alternating while one was still depressed).
(*) Fixed bug where sliders would go at old speed even after a new timing point.
(*) Fixed bug where every tick on a slider would be counted as a miss if missed.
(*) Fixed normal hit sound not playing when effect volume is set below 20%.
(*) Allow negative offsets in manual timing adjustment window.
(*) Fixed kanji for 'katsu' combos.  The left-hand particle was incorrect in all sprites.  Oops.

2007-09-25 (b72)
(+) Added audio offset to options.
(*) Changes to allow other localisations to handle numbers correctly.
(*) Fixed bug where snapping would not work when a song had exactly two timing points.
(*) Changed song selection quite a lot.  <b>Need feedback on this.</b>
(*) Fixed sort order when stars are the same but difficulty differs (by a decimal place).
(*) Aaaaaahhh! Fixed spinners being HARDER on easy mode.

2007-09-24
(+) Framework for play mods.
(+) Two initial mods - "nofail" and "easymode".
(+) Heavier gridlines to show the centre of gamefield in editor.
(*) Grid resizing/non-standard resolutions handled a lot better.
(*) Fixed bug where editor menu selections would become out of sync after exiting/entering.
(*) Fixed bug with horizontal and vertical flipping losing notes.
(*) Fixed bug where short sliders would not play the end-circle sound in edit mode at higher BPMs.
(*) Fixed bug where songs containing characters which are invalid in filenames were being incorrectly handled.
(*) Fullscreen mode will exit whilst in the editor, and resume on exiting.  The editor doesn't support fullscreen at this point in time.
(*) Song continues to play while at the ranking screen.
(*) Added a note to inform about the lack of online ranking functionality for the moment.
(*) Fire starts at 30 combo rather than 40.
(*) Fixed bug where game would not start if fullscreen was set in configuration file.
(*) Made selection of last songs in song selection menu a lot easier.

2007-09-23
(+) Volume controls in options.
(+) Replay support..?
(*) Moved song extraction to selection menu rather than as the game starts.
(*) Game will start even without any beatmaps present.  The message will now appear when you try to play or edit.
(*) Menu effects don't play and song selection doesn't change while osu! doesn't have focus.
(*) If fire fails to render, it is automatically disabled rather than crashing the game.
(*) Fixed bug where high BPMs would cause an error when attempting to manually set the bpm via the dialog.
(*) Started on new slider rendering code.

2007-09-22
(+) Login handling.
(*) Update notification disappears while playing/editing.
(*) Increased difficulty of combo end-scores, but introduced a hp bonus even when you miss both types of combo.

2007-09-21
(+) Circles shake when out of order.
(+) Slider velocity adjustment added to editor.
(*) Hopefully fixed bug with unsupported characters.
(*) Oops, I did a build too early.  Removed slider velocity from internal version.
(*) Notes under the end of sliders now stack.  Makes it a lot easier to see these.
(*) Metronome ticks and metre are a lot more sane.

2007-09-20
(*) Reordered slider-tick sprites to be beneath repeat/end circles.
(*) Two crosses appear when missing a slider altogether, at the start and end points.
(*) No cross appears when missing the start point of a slider.
(*) Fixed bug where short sliders could not be placed correctly.
(*) Fixed bug where end circles acted as start circles too.
(*) Fixed bug where game would crash on entering play mode while a song was playing which does not have any beatmaps.

2007-09-19
(+) Basics to allow osu! to check for new updates when it is run, and present an option for the user to get updates.
(+) Linear curve type.  Can now place hard cornered sliders.
(*) Md5 can be checked in the currently open application.  Changed updater to use this rather than hard-coded version number.
(*) Fixed issue where slider length is saved as non-integer, but causes crash on load.
(*) Fixed bug where resizing a spinner caused the game to crash.
(*) Snapping turned back on for hitcircles and sliders - and extended so circles snap to the end and the start of sliders.
(*) Broke sliders, but fixed them again..

2007-09-18
(*) Fixed some songs not remaining transparent after being selected.
(*) Fixed bug where config file is not saved when using the 'X' button to close the window.
(*) Disabled hitcircle snapping to other hitcircles.
(*) Fixed bug where slider point editing was playing up when a slider was selected, but you hovered over another slider.
(*) Fixed bug where slider end circles occasionally appeared way too large in the editor.
(*) Standardisation of osz extracted directory names and osu filenames.

2007-09-17
(+) Song grouping.  How does this work for you guys?
(*) Changed some difficulty settings.  HP drain should be a bit more reasonable, i hope!
(*) Extracts .zip files in songs directory as well as .osz.  IE doesn't play nicely with archives.
(*) Handle crash when incomplete osz files are still downloading when osu! is started.
(*) Spinner has a bit more acceleration.
(*) Fixed bug where spinner/slider sounds gets stuck playing.

2007-09-16
(+) HAJIMATTAZO! internal BETA RELEASE!
(+) Osz packaging support.
(*) Fixed md5 checksumming of utf8 containing files.
(*) Slider start circles are closer than the ball.
(*) Score multiple increases with difficulty.
(*) Tweaks before internal release.
(*) Fixed bug with osz where it would try to zip itself.
(*) Mousewheel zooms on timeline.
(*) Metronome sound aligned for first beat.
(*) Reduced brightness of screen flashes on selection.
(*) Audio flow is better between same songs different versions.
(*) Made slider circle a bit less sensitive.
(*) Made easy mode a bit easier.

2007-09-15
(+) Added version suffix to metadata for songs.
(+) Added a few graphics options.
(*) Same song continues through multiple menus without interruption if possible.
(*) High score entry screen shows what place you ranked.
(*) Slightly more friendly error dialog.
(*) Fixed audio samples a bit more (maximum concurrent samples lowered to more sane limits).
(*) Sliders can be placed with no beat snapping.
(*) Spinner placement icon is smaller.
(*) MPEG and other slow-seeking formats will now behave a lot better.
(*) Added number to fadeout animation for hitcircles.  Made them scale a bit further too.
(*) Selection is ordered by difficulty stars if the other fields match.
(*) Fixed video size bug.
(*) Handling no beatmaps present and beatmaps with no notes.

2007-09-14
(+) Play/pause/stop controls in editor.  About time haha.
(+) Slider points can be removed (right click).
(+) Sliders can be extended to add/remove repeats by resizing the end of them on the timeline.
(+) Grid/time snapping can be temporarily disabled by holding shift.  This works for placement and editing.
(*) Fixed bug with gamefield alignment at higher resolutions.  Surprised I was the first to notice this!
(*) Fixed spinner placement - behaves more like slider placement with the setting of duration.  Doesn't play sounds unnecessarily.
(*) Fixed bug where slider sliding sound would not play on some PCs.
(*) Removed a few redundant menu items.
(*) The osu! logo on main menu now beats in time to timed songs.
(*) TimingPoints are now handled on a higher level (seems like a better place to deal with these too).

2007-09-13
(+) Video seeking, pausing, rate changing.  Can now be displayed in the editor :).  Not on the timeline yet, but hopefully before the first internal release this will be complete.
(*) Vast improvements to video synchronisation.
(*) Video texture swapped to managed so changing resolutions wouldn't break.  Hopefully not too much performance loss because of this.
(*) Gamefield resizing is back in (ala design mode)
(*) Difficulty wireup for hit accuracy, miss score loss, preempt of circles.
(*) After further discussion, once again changed the hp calculation algorithm.  Now ensures a minimum "average HP recovery" per beat in the song.
(*) Slider radius updates after circle size change.
(*) Spacebar plays/pauses the song in edit mode.
(*) Ranking progresses to name entry automatically if left alone.
(*) Graph finishes graphing properly if interrupted with a click early.

2007-09-12
(+) Difficulty stars next to song in selection mode.
(+) Most of difficulty settings now take effect!
(*) Fix for slider tick rates which are non-integer.
(*) Adjusted menu somewhat.  Fixed up the underlying code to support many sprites per song selection box.
(*) Slider lines on timeline were 1 pixel too big.  Yes I'm picky :).
(*) Limited open/save dialogs to .osu file extension.
(*) Fixed bug where songs that did not yet have an osu were not showing up in edit list.
(*) Set default edit modes on editing a new song - popup song setup window then go straight to timing. Woo.
(*) Fixed bug where screen sometimes does not fade in fully.

2007-09-11
(+) Basic options.
(+) New song setup dialog with difficulty settings.
(+) Support for named high scores.
(+) Some basic audio samples in the menus.  Spinner bonus sound sample.  Fail sample.  Weeeeeee.
(+) Bonus shows on spinners.
(*) Editor titlebar displays current filename.
(*) Updated selection screen to show rankings.
(*) Added support for multiple beatmaps per song.
(*) Improvements to interface in lots of areas.
(*) Removed video rendering from editor (video can't skip around yet - need to implement this).
(*) Added a confirmation dialog when clearing all beats from a song.

2007-09-10
(+) Ranking screen initial version.
(+) Dynamic health calculation.  Totally changes the scoring system to be a lot more dependent on combos (similar to ouendan!)
(*) Fixed bug where mouse cursor doesn't retract during transitions.
(*) Converted all scoring types to enums.
(*) Increased the speed of the hitmetre Ki to match ouendan.  Also ensure that it reaches max before the first hitObject is hit.
(*) Added delay where click is not accepted after auto-clicking on hover.
(*) Fixed bug where equal scores would be recorded more times than should be possible.

2007-09-09
(+) New class BeatmapManager handles loading of all beatmaps initially.
(+) Metadata input dialog accessible using the "song information" menu option, or from the options menu.
(+) New version of song selection menu.  Full song access once again :).
(+) Options menu.  Still empty, but its there!
(*) Fixed some misaligned controls.
(*) Lots of new additions to SpriteManager.  Handles easing in tweens, hover transformations, more origin and scaling types and quite a bit of other stuff I needed to get the new menu working.
(*) Default button settings on dialog popups.
(*) High score list stores up to 5 scores per song.
(*) Title song is random.
(*) Removed shortcut keys from main menu (and redirected others).
(*) Fixed bug where md5 could not be read of beatmaps in some cases.
(*) Titles with ':' characters were getting cut off.
(*) Holding down shift while increasing/decreasing bpm.
(*) Video sync added to [Events] section of osu files.
(*) Refinement of video texture copy code.  Hopefully improved performance on some systems. 

2007-09-08
(+) Initial version of new main menu.
(+) Spinning sound added.
(!) Re-rendered all sprites at 1.6x the resolution (supporting 1024x768).  Also changed file format for some larger textures.
(*) Fixed slider border to be relative to slider radius (for multires display).
(*) Fixed spinner centre being off when running at higher resolutions.
(*) Fixed spinner velocity with non-standard framerates.
(*) Score bar is no loner based on draw fps.

2007-09-06
(+) Spinners fully implemented (still need sounds).
(+) Spinner placing in edit mode fully implemented.
(*) Spinners have a syncing problem at sub-60fps.  Tried a lot but couldn't fix this one.  Needs a bit more thinking..
(*) Fixed bug where reversing sliders would cause abnormalities.

2007-09-05
(+) Added slider path guides.  You can now see the path behind the slider.
(+) Full point editing on sliders!
(+) Added a confirm save changes dialog popup when exiting the editor.
(+) Spinners nearly fully implemented!  Can't place yet in the editor, though.
(*) Changed slider point placement style.  If you click a point that has already been placed while placing, it will be removed.  There is also no minimum length to place a point anymore - since you can see where these points are it won't be confusing to allow this.
(*) Fixed bug with beat snapping all beats.  Didn't consider new timing points - nor would it snap notes before the song start.
(*) Fixed bug with snapping single beats on timeline.  Left mouse off a few pixels from where it felt like it should be.
(*) Fixed bug where song md5 would not be resolved correctly, instead placing a huge exception log in the osu file.
(*) Changed right-click to bypass a selection and delete either a hovered object or nothing, unless an object in the selection is clicked directly.
(*) Changing curve type in the menu also converts the selected slider if necessary.

2007-09-04
(!) Moved all game files to new server.  Updating should be a lot faster :).
(+) Added new selection option - Reverse selection.  Reverses the timing, keeping all placements intact.
(+) Hooked up spinner score metre.  Able to increase/decrease by shifting the sprite around.  Not visible in-game yet!
(*) Hit circles fade out after the exact hit time.
(*) Cloning beats places them in a more suitable location.
(*) Fixed bug where some sliders could not be hit for the full possible score.

2007-09-03
(+) Added ConfigManager.  Currently just remembers the resolution over multiple executions.
(+) Added whistle sound for sliders (during the duration of a slide).  I wonder how this sounds?
(+) Spinner textures are in.  Doesn't work yet, but i need to do a build anyway :).
(*) Resampled hitwhistle sound.  Less distortion, less volume.
(*) Decreased the active area on timeline hitcircles (to make selecting ranges in crowded areas a bit easier).
(*) Fixed audio sync at 0.25x playback rate.
(*) Fixed bug where cloning sliders would not inherit correct curve type.
(*) Fixed bug where loading with a selection would cause abnormalities.
(*) Fixed bug where slider ticks could be sounded (and would disappear) in play mode after already missing them.  This did not affect scoring.
(*) Changed slider arrow rotation to be a bit less obvious.

2007-09-02
(+) Bezier curves are in! Catmull-Rom is still default, but this can be swapped from the options menu.
(+) Metronome sounds in timing mode.  No sounds from placed beats (people found these distracting).
(+) Slider arrows rotate according to general direction at time of repeat.
(*) Changed slider sound - louder and less initial velocity.
(*) Fixed bug where changing a slider to a new combo didn't work as expected.
(*) Changed audio sync in editor.  Seems to be a lot closer to gameplay than it was before.
(*) Fixed remaining multiple resolution issues.
(*) Turned frame buffering of video back on after reported better performance.  Still needs some tweaking..

2007-09-01
(+) New exe format.  Compressed and less dependencies!
(+) Timing menu.  New dialog to manually input timing values.  Menu access to add multiple timing points (still need to add buttons to the actual game interface though).
(+) Support for multiple resolutions.  Mostly done - sliders are still looking a bit strange, but hopefully this will be fixed in my rehash of sliders tomorrow.  Still need resampling - this doesn't look so great at the moment.
(+) Sliders look a LOT nicer.  Performance should be considerably higher too - although I still believe I have a bit of work to do in this area.
(*) A huge number of optimisations.  CPU usage was getting quite high with songs containing 400+ beats.  Reworked quite a bit of code to optimise performance in editor and (especially) play modes.
(*) A maximum of one untimed timing point can be placed at once.

2007-08-31
(+) Added magnification controls for the timeline.
(+) Preliminary visualisation of timing points on timeline.  See yesterday's changes for controls.
(*) Fixed a huge bug with the reading of timing from the new file format.  How did I miss that!
(*) Fixed bug where md5 of song would not output correctly to the osu file.
(*) Fixed bug where starting sliding on a slider too early would not negatively impact score/combo.
(*) Fixed bug where BPM could end up negative when using multiple timing points.
(*) Increased volume of finish hit.

2007-08-30
(+) Multiple timing points.  Basically means a song can change BPM at any point and you can simply add a new timing from that point forward.  Should be quite a handy little addition :).  I haven't added UI buttons for this functionality, but if you feel like testing, it is availble using Ctrl+P (new timing point), Ctrl+O (retime current point) and Ctrl+I (delete timing point).  You can time each point by tapping as usual!
(*) Revamp of the .osu format to v2.  Backwards compatibility is held.  To update your osu files just load and save in the editor once.
(*) Fixed bug where changing modes while placing a slider caused trouble when placing any other sliders (had to right click first)
(*) Fixed bug where seeking in a song while playing would cause some REALLY loud noise.  Ouch.
(*) Beatsync storage is handled a lot better internally.

2007-08-29
(*) Timeline can be fully used while in ANY mode!  If not in select mode, any selection will be lost when the cursor enters the gamefield.
(*) Dragging is handled a *lot* better.  Dragging from the centre of a slider will retain the click position offset.  Same goes for moving notes around - while its less noticeable in this case.
(*) Sliders can be selected by clicking on them anywhere in the timeline, rather than just the beginning.
(*) Fixed alignment of not-beatsynced message.
(*) Fixed bug where trying to place a slider near the timeline would fail badly.
(*) Fixed bug where selecting all notes more than once would cause fun.
(*) Reimplemented area selection quad code to be more efficient.  Huge CPU cycle reduction from this!

2007-08-28
(+) New timing interface.  Pretty bare at the moment, but allows graphical control over the bpm and offset, as well as providing a reset function for the general timing.
(*) Grid precision is controllable from the menu.
(*) Snap divisor is controllable from the menu.
(*) Mouse trail behaves correctly when the game is first loaded.  Doesn't fly in from nowhere :).
(*) Fixed bug where altering bpm/offset after a reset or before timing causes really bad results.

2007-08-27
(+) Menu bar in editor.  Keep in mind some of the options are yet to be handled properly, and will do nothing!
(+) Sliders' bodies show up fully in the timeline.  Reverse circles also show up along the way.
(*) Adding this meant that all the screen positions needed a vertical offset.
(*) This also broke slider drawing code, so I attempted to fix this up as much as possible.
(*) Made sliders look a lot better when they are too sharp.  Still could do with improvement, but a LOT better.
(*) Fixed bug where song would crash if no notes were placed before playing.
(*) Fixed bug where the start of sliders could be clicked multiple times to gain extra points and combo.

2007-08-26
(+) FIIIIIIIIIIIIIIIIIIIIIRE!
(+) Ki metre changes to a danger '!' at low hp.
(*) Larger mouse cursor.  Now uses a spriteManager - one less spriteBatch.
(*) Editor uses windows mouse cursor.  This seems to feel a bit better?
(*) Fixed bug where combo end hits would not increase the combo counter.
(*) Properly release directshow handle... was causing really bad crashing.
(*) Uneven slider end points more resilient.
(*) MoveTo() for pSprites now works when getting updated every frame.

2007-08-25
(*) Fixed bug where slider sounds/scoring points would not match up with visual points on uneven beat sliders.
(*) Fixed bug where hitcircles would randomly disappear in the editor.

2007-08-24
(*) Played with thread priority.  Made very little progress, but seems to be a bit more stable?
(*) Allowed for video to resync once after frames begin to flow in.  Seems to help for older ffdshow versions.

2007-08-23
(*) Video is a lot more robust.  Drops frames, thread prios more sensible.
(*) Refactoring usage of spriteBatch.  Less calls overall, but still room for improvement.

2007-08-22
(+) Hit sprite animation bulges slightly before returning to normal size.
(+) Initial video support! woooot!
(*) Hit sprites are larger, more spiky, and generally more finished.
(*) Hit sprites fade rather than zooming out.  This replicates ouendan more closely.
(*) Follow circles split to new sprite.  Small changes.

2007-08-21
(+) Combo end hits now display the overall combo sprite.
(*) Huge changes to the hit sprites.  Should look a lot more ouendan authentic now.
(*) Fixed bug where slider reverse sound plays late when it actually shouldn't at all.
(*) Made spacing of first follow-line sprite a bit more lenient.  Should look a bit more aligned.

2007-08-20
(+) Follow path is now a series of sprites.  Looks a lot better (although currently reusing sliderscore sprite).
(*) Fixed bug where missing the first hit of a slider doesnt have negative effects.
(*) Reverse arrows start pulsating as soon as they are displayed, rather than only after the slider starts.
(*) More code organisation.

2007-08-19
(+) Hitcircles stack!
(+) Cut, Copy and paste added in addition to duplication.
(*) Slider sprites are generated on the fly when they are to be displayed.
(*) Scoring starts close to the first note, and ends after the last programmed note (can rank songs which are incomplete)
(*) Fixed high scores resolving wrong file path resulting in no saves.
(*) Huge code tidying.

2007-08-17
(*) Fixed end of sliders not syncing up properly in play and edit modes.
(*) Moved some code for autoplaying sounds into HitObjectManager and made an AutoPlay flag.

2007-08-16
(+) Horizontal and vertical flipping.
(+) Duplication of note sequences.
(*) Sliders length is saved to the osu.  No longer dependant on divisor.

2007-08-14
(*) Fixed up audio sync of beats in editor.
(+) Slider sounds for endpoints and repeats.
(*) Slider ticks no longer missed in play mode.

2007-08-13
(*) Slider placement left/right click options more refined.
(*) Guiding lines join from correct end of slider.
(*) Fixed bug where osu! would crash if a file existed it was attempting to move.
(*) Fixed a slider texture creation memory leak.
(.) General code restructuring.
(-) Introduced an unfixed bug where sliders rely on editor's divisor..

2007-08-12
(+) Timeline sliding.
(+) Duplication in editor (ready for copy+pasta).
(*) Selection fixed for overlapping objects.
(*) REMOVED SYNC FORMULA.
(*) Fixed timing inconsistencies in lower playback speeds (hopefully).

2007-08-11
(+) Audio rate controls (buttons and marker).
(*) New menu graphics.  Converted next/prev buttons to nice images.
(*) Chose more nice-looking fonts.  All AA'd now.
(*) Slider dots only disappear if 'hit'.
(*) Sliders explode at both sides on completion!
(*) Each song has its own directory.  Old files will be moved automatically.
(*) Transition will not interfere with start of song.

2007-08-11
(*) Slider refactoring.  Curves are placed properly, with a bit more error checking?  Still needs a lot more.

2007-08-09
(*) Took a bit of a break.  Maybe I can start working a bit more seriously on this again? :/
(*) Seeking is now done to the beat, rather than based on a fixed time amount.

2007-08-01
(*) Sliders handle a lot better.
(*) Scoring at end of slider is fixed.
(*) Repeats are now placed depending on how long you hold the slider before ending it with RMB.
(+) A bit of error-checking when placing sliders.

2007-07-31
(*) Did something, but can't really remember so well.

2007-07-30
(+) Sliders are scored.
(*) Major rewrite of scoring code.  Not totally dynamic yet, but getting there!

2007-07-29
(+) Sliders have balls.  2 of them (well actually, just one).
(+) Sliders have scoring points.  Times are stored in a separate array.
(+) Sliders work on play mode.  No scoring as of yet.
(*) Better code for depth helper methods in SpriteManager.

2007-07-28
(+) Sliders save and load.
(*) Recreated follow circle graphic - thicker and textured orange.
(*) Fixed bug in spriteManager which caused some current values to not be read from future transformations.

2007-07-27
(*) More slider drawing optimisation.
(+) Added graphic for reversible sliders.

2007-07-25
(*) Moved and optimized a lot of slider drawing code around.
(+) Sliders have follow circles.

2007-07-24
(*) A song which is not beatsynced will default to no beat snapping.
(*) Slider follow-circle moves smoothly.
(*) Sliders can be moved position-wise.
(+) Sliders are reversible

2007-07-22
(+) Sliders have a circle following them.  Movement is pretty ugly, but still.

2007-07-20
(*) Code cleanups.  Should've probably done more!

2007-07-19
(+) Curve rendering has border.  Still a bit dodgy.  Slow but consistant progress, i guess?

2007-07-18
(+) Initial slider curve rendering code.  Currently only in the editor (no slider object).

2007-07-14
(*) Seekbar is now a lot more grabbable..

2007-07-13
(+) Seekbar
(*) Moved a lot of audio code around.  Allow for virtual seeking to reduce cpu load.

2007-07-12
(+) Timeline selection and moving.
(+) Score bar.  Currently doesn't take the .osu into account, so could be too easy/harsh.
(+) Selection boxes are shaded.
(+) Osu! sounds will play in the editor when in play mode (beat/whistle/finish).

2007-07-11
(+) Moved audio code to AudioEngine.
(+) Better organisation of classes!
(+) Score now shows in a similar fashion to ouendan - always shows 8 digits.
(+) Combo number zooms a bit when you increase it.
(+) Can move groups of notes in time (currently only using keyboard shortcuts)
(+) Timing mode timeline is magnified automatically, and lines are longer
(*) Fixed bug with quick loading duplicates.
(*) Hit circle numbers a bit too low with new aligning code.

2007-07-10
(+) Timeline for beatmap
(+) Multiple selection using ctrl.
(*) Played around with texture loading on a separate thread, but not too much luck..
    Have commented this code out for now - will work on it further if there is a large
    performance hit from loading many textures.
(*) Fixed bug where hit circles could be moved outside the gamefield area.

2007-07-09
(+) New version of pUpdater - async downloads means the window won't freeze.
    Progress bar also works, and connection errors are handled more sanely.
(+) Buttons can be shared between menu modes.
(+) Full area selection of notes.  Can change position and sound type, as well as delete.    

2007-07-08
(+) New editor menu system... well the beginning of.
(*) Tried some new beat sync algorithms, but not too much luck.  Need to work on this some more

2007-07-07
(+) Moved all old code to use the new SpriteManager (circle display etc.)
(*) Happy birthday to me

2007-07-06
(+) Initial work on SpriteManager - providing a framework for all sprite display.
    This is partly to clean up some code, and partly so we can begin to script some
    background images and animation.

2007-07-05
(+) Support for ogg files
(+) High scores (local only for now)
(*) Clicking outside game area in editor won't place note
(*) Moved songs to a subfolder to keep things tidy

2007-07-04:
(+) New menu system
(+) Beat snapping
(+) Lots more i forgot... first changelog entry (should've started earlier..)
